#ifndef SCT_ANALYSISSERVICE_FITTERARGUMENTS_H
#define SCT_ANALYSISSERVICE_FITTERARGUMENTS_H
#include "SctService/Arguments.h"

namespace SctAnalysis {
/** Command line arguments available for fitting service */
class AnalysisArguments : public SctService::Arguments {
 public:
  /** 
      constructor builds from command line args 
  */
  AnalysisArguments(int argc, char** argv);
  /**
     get FitStrategy name
  */
     std::string getStrategyName() const;
  /**
     options used by FitStrategy
  */
  std::string getFitOptions() const;
  /** 
      overload SctService::Arguments::printHelp(std::ostream)
  */
  void printHelp(std::ostream& os) const;
  /**
     overload SctService::Arguments::parse()
  */
  virtual void parse();
private:
  AnalysisArguments();
  std::string m_strategy;
  std::string m_options;
};
}

#endif
