//#include "Sct/isstream_bugfix.h"
#include "Streamer_Test.h"
#include "Sct/Archive/IOManagerArchiveFile.h"
#include "CalibrationController/Serialization/TestDataWrapper.h"
#include <sstream>

using namespace boost;
using boost::unit_test_framework::test_suite;
using namespace std;
using namespace Sct;
using namespace Sct::Archive;

namespace SctArchiving{

  void test_TestData(){
    shared_ptr<Serializable> ob = IOManagerArchiveFile::instance().read("./TestData.1008.0.StrobeDelayTest.gz");
    shared_ptr<SctCalibrationController::TestDataWrapper> isi = 
      dynamic_pointer_cast<SctCalibrationController::TestDataWrapper>(ob);
    BOOST_CHECK(isi.get() != 0);
    BOOST_CHECK_EQUAL ( isi->getClassName(), "TestData");
    BOOST_CHECK_EQUAL ( (std::string) isi->getUniqueID() , (std::string)"1008.0.StrobeDelayTest");
  };

  Streamer_Test::Streamer_Test(){
    add(BOOST_TEST_CASE(&test_TestData));
  }
}
