#include "PipelineConfigUpdater.h"
#include "ConfigUpdaterManager.h"
#include "../SctApiAccessException.h"
#include "../SctApiCall.h"

#include "Sct_SctApi/SctApi.hh"
#include "Sct/SctParameters.h"
#include "Sct/SctNames.h"
#include "SctData/PipelineTestResult.h"
#include "SctData/DefectPrototype.h"

#include <TF1.h>

using namespace SctData;
using namespace Sct;

namespace SctCalibrationController {

bool PipelineConfigUpdater::inMap = ConfigUpdaterManager::instance().setUpdater("SctData::PipelineTestResult", shared_ptr<PipelineConfigUpdater> (new PipelineConfigUpdater() ) );

void PipelineConfigUpdater::update(const TestResult& testresult, Sct_SctApi::SctApiIPC_ptr api) const {
    const PipelineTestResult& t = dynamic_cast<const PipelineTestResult&> (testresult) ;


    // This updated the mask in the configuration with STUCK and DEAD information.  
    // Later, (in athena) this mask is used. -- BD

    maskChannels(t, UNUSEABLE, api);

    SctNames::Mrs() << "CC_UPDATE_INFO" << MRS_TEXT("CalibrationController updating mask registers from PipelineTest") << MRS_DIAGNOSTIC << ENDM;
}
}

