#include "SequenceRequestWorker.h"
#include "Sct/Exception.h"
#include "Sct/CorbaExceptionWrapper.h"
#include "Sct/StdExceptionWrapper.h"
#include "Sct/BugReport.h"

namespace SctCalibrationController {

    void SequenceRequestWorker::operator () (){  // does not throw
	Sct::Throwable* mrs = 0;
	try {
	    cout << "In SequenceRequestWorker operator () 1" << endl;
	    Sct::BugReport("BUG01","SequenceRequestWorker.cpp","In SequenceRequestWorker operator () 1/4");
	    m_cc.executeSequence(m_sr);
	    Sct::BugReport("BUG01","SequenceRequestWorker.cpp","In SequenceRequestWorker operator () 2/4");
	    m_cc.status.status = m_cc.status.INCONTROL;  // was originally set to BUSY by CalibrationControllerImpl.
	    Sct::BugReport("BUG01","SequenceRequestWorker.cpp","In SequenceRequestWorker operator () 3/4");
	    m_cc.updateStatus();
	    Sct::BugReport("BUG01","SequenceRequestWorker.cpp","In SequenceRequestWorker operator () 4/4");
	    cout << "End of SequenceRequestWorker operator() 4" << endl;
	} catch(Sct::Throwable &e) {
	    e.sendToMrs(MRS_ERROR);
	} catch(std::exception &e) {
	    mrs = new Sct::StdExceptionWrapper(e);
	} catch(std::string &s) {          // Just in case	
	    std::ostringstream os;
	    os<<"uncaught string expection "<<s;
	    mrs = new Sct::Error(os.str(), __FILE__, __LINE__);
	} catch(CORBA::Exception& e){
            Sct::CorbaExceptionWrapper(e, "error in SequenceRequestWorker thread", __FILE__, __LINE__).sendToMrs(MRS_ERROR);
	} catch(...) {
	    mrs = new Sct::Error("uncaught unknown exception", __FILE__, __LINE__);
	}
	if (mrs) {
	    mrs->sendToMrs(MRS_ERROR);
	}
    }
}
