#include "IsInfoWrapper.h"
#include "Sct/LogicErrors.h"
#include "Sct/IoExceptions.h"
#include "Sct/SctNames.h"
#include <is/info.h>
#include <is/infodictionary.h>
#include <is/infoiterator.h>
#include <is/inforeceiver.h>
#include <is/infoT.h>

namespace SctCalibrationController {
  IsInfoWrapper::IsInfoWrapper(boost::shared_ptr<ISInfo> info) : wrapped(info){
  }

  IsInfoWrapper::~IsInfoWrapper(){}

  boost::shared_ptr<const ISInfo> IsInfoWrapper::getWrapped() const{
    return wrapped;
  }

  boost::shared_ptr<ISInfo> IsInfoWrapper::getWrapped(){
    return wrapped;
  }

  void IsInfoWrapper::publishWrappedObject(const string& serverName) const {
    ISInfoDictionary& is = Sct::SctNames::getISDictionary();
    string name=serverName;
    name+=".";
    name+=getClassName();
    name+=".";
    name+=getUniqueID();
    ISInfo::Status s = is.insert(name, const_cast<ISInfo&>(*getWrapped()));
    if (s != ISInfo::Success) throw Sct::IsException(s, name + " publish failed", __FILE__, __LINE__);
  }
}
