#include "TestDataWrapper.h"
#include "Sct/LogicErrors.h"
#include "CalibrationController/IS/TestData.h"

namespace SctCalibrationController {
  std::string TestDataWrapper::getClassName() const{
    return "TestData";
  }

  Sct::UniqueID TestDataWrapper::getUniqueID() const {
    shared_ptr<const TestData> wrapped = boost::dynamic_pointer_cast<const TestData>(getWrapped());
    if (!wrapped.get()) throw Sct::IllegalStateError("No wrapped object",__FILE__,__LINE__);
    return Sct::UniqueID(wrapped->runNumber, wrapped->startScanNumber, wrapped->testName);
  }

  TestDataWrapper::TestDataWrapper(boost::shared_ptr<TestData> td) : IsInfoWrapper(td) {
  }  
}
