#ifndef DEFAULTSEQUENCE_H
#define DEFAULTSEQUENCE_H

#include <boost/shared_ptr.hpp>

#include "../ipc/SequenceRequest.h"
#include "../ipc/CalibrationController.h"
#include "../ipc/TestRequest.h"
#include "../ipc/CalibrationController.hh"
#include "Sct/OmniMarshalling.h"
#include <iostream>
#include "Sct/BugReport.h"

using namespace std;
using namespace boost;

namespace SctCalibrationController {
    
using namespace Ipc;

namespace Scripts {
    
class DefaultSequence : public SequenceRequestImpl {
public:	
    static Sct_CalibrationController::SequenceRequest_ptr instance(Sct_CalibrationController::TestRequest_ptr r){
        static DefaultSequence s;
	s.request=Sct_CalibrationController::TestRequest::_duplicate(r);
	return s._this();
    }
        
    virtual char * startSequence(Sct_SctApi::SctApiIPC_ptr api) {
      Sct::BugReport("BUG01", "DefaultSequence.h","IS IT THIS ONE? startSequence");
      return ::Sct::copyStringToCorba("DefaultSequence");
    }
    
    virtual Sct_CalibrationController::TestRequest_ptr getNextTest(unsigned long index) {

      if (index == 0) {
        return Sct_CalibrationController::TestRequest::_duplicate(request);
      };
      return Sct_CalibrationController::TestRequest::_nil();   
    }

    virtual void endSequence() {}

private:
    Sct_CalibrationController::TestRequest_var request;
    DefaultSequence() {} // do not use
};

}
}
#endif //DEFAULTSEQUENCE_H
