;
;  Copyright 2000 by Texas Instruments Incorporated.
;  All rights reserved. Property of Texas Instruments Incorporated.
;  Restricted rights to use, duplicate or disclose this code are
;  granted through contract.
;  U.S. Patent Nos. 5,283,900  5,392,448
;
; "@(#) DSP/BIOS 4.00 03-27-00 (barracuda-e08)"
;
;  ======== vectors.asm ========
;  Plug in the entry point at RESET in the interrupt vector table
;

;
;  ======== unused ========
;  plug inifinite loop -- with nested branches to
;  disable interrupts -- for all undefined vectors
;
unused  .macro id

		.global unused:id:
unused:id:
		b unused:id:    ; nested branches to block interrupts
		nop 4
		b unused:id:
		nop
		nop
		nop
		nop
		nop
		
		.endm

		.ref    _pin4Isr
		.ref    _pin5Isr
		.ref	_frameDmaDoneIsr
		.if $isdefed("SIM")
			.ref	_async
		.endif
		
		.sect ".vectors"
		.ref _c_int00           ; C entry point
		.align  32*8*4          ; must be aligned on 256 word boundary

RESET:                          ; reset vector
		mvkl _c_int00,b0        ; load destination function address to b0
		mvkh _c_int00,b0
		b b0                    ; start branch to destination function
		mvc PCE1,b0             ; address of interrupt vectors
		mvc b0,ISTP             ; set table to point here
		nop 3                   ; fill delay slot
		nop
		nop
		
		;
		;  plug unused interrupts with infinite loops to
		;  catch stray interrupts
		;
		unused 1
		unused 2
		unused 3

INT4:	b	_pin4Isr
		nop
		nop
		nop
		nop
		nop
		nop
		nop

INT5:	b	_pin5Isr
		nop
		nop
		nop
		nop
		nop
		nop
		nop

		unused 6
		unused 7

INT8:	b	_frameDmaDoneIsr
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		
		unused 9
		unused 10
		unused 11
		unused 12
		unused 13

		.if $isdefed("SIM")
INT14:		b	_async
			nop
			nop
			nop
			nop
			nop
			nop
			nop
		.else
			unused 14
		.endif

		unused 15
