#ifndef SCT_CORBAEXCEPTIONWRAPPER_H    
#define SCT_CORBAEXCEPTIONWRAPPER_H

namespace Sct {
  class CorbaExceptionWrapper; // fwd dec
};

#include "Sct/IoExceptions.h"
#include "ipc/core.h"

namespace Sct {

/**
 * Thrown to indicate an error with an Ipc call.
 * @ingroup Exceptions     
 * @author Alan Barr 
 */
class CorbaExceptionWrapper : public IoException {
public:
  static std::string whatDoesThisCORBAExceptionTellUs(const CORBA::Exception &) throw ();
    /**
      Creates an Exception with message msg
      */
    CorbaExceptionWrapper(const CORBA::Exception&, const string& msg, const string& file, int line) throw();
    
    virtual shared_ptr<Throwable> clone() const throw();
    virtual string getMessage() const throw();    
    virtual ~CorbaExceptionWrapper() throw();
protected:
    string m_name;
    CorbaExceptionWrapper() throw() {}   
};
}
#endif //SCT_IPCEXCEPTION_H
