#ifndef SCT_ISUTILITIES_H
#define SCT_ISUTILITIES_H
#include <string>
#include "is/info.h"
#include "mrs/message.h"

namespace Sct{

  /** Utility methods for using with the information service 
      @author alan.barr@cern.ch*/
class ISUtilities{
public:
  /** 
   * Add a ISInfo to IS, with a name, or if it exists, replace it. 
   * The arguments file and line should be __FILE__ and __LINE__, 
   * so that if the additions is not successful, an IsException with 
   * sensible parameters can be thrown. The final arg is optional setting
   * of the severity of the MRS message which will be sent it it fails
   */
  static void addOrUpdateOrMessage(std::string& name, ISInfo& info, const std::string& file, int line, severity sev);
   /** 
   * Add a ISInfo to IS, with a name, or if it exists, replace it. 
   * The arguments file and line should be __FILE__ and __LINE__, 
   * so that if the additions is not successful, an IsException with 
   * sensible parameters can be thrown.
   * of the severity of the MRS message which will be sent it it fails   
   */
  static void addNoUpdateOrMessage(std::string& name, ISInfo& info, const std::string& file, int line, severity sev);

  /** 
   * Add a ISInfo to IS, with a name, or if it exists, replace it. 
   * The arguments file and line should be __FILE__ and __LINE__, 
   * so that if the additions is not successful, an IsException with 
   * sensible parameters can be thrown. The final arg is optional setting
   * of the severity of the MRS message which will be sent it it fails
   */
  static void addOrUpdateOrThrow(std::string& name, ISInfo& info, const std::string& file, int line, severity sev);
   /** 
   * Add a ISInfo to IS, with a name, or if it exists, replace it. 
   * The arguments file and line should be __FILE__ and __LINE__, 
   * so that if the additions is not successful, an IsException with 
   * sensible parameters can be thrown.
   * of the severity of the MRS message which will be sent it it fails   
   */
  static void addNoUpdateOrThrow(std::string& name, ISInfo& info, const std::string& file, int line, severity sev);
private:
  ISUtilities();
};

}

#endif
