
#include "Tokenize.h"


using std::string;

namespace Sct {

  Tokenize::Tokenize(const string& str,
		     const string& delimiters) {

    Tokens & tokens = m_tokens;
    string::size_type lastPos = 0;  // where the "interesting" strings start
    // Find first "non-delimiter".
    string::size_type pos;
    
    while (true/*string::npos != pos || string::npos != lastPos*/) {
      pos = str.find_first_of(delimiters, lastPos); // pos of next delimiter
      tokens.push_back(str.substr(lastPos, pos - lastPos));
      if (pos==str.npos) {
	return;
      };
      lastPos = pos+1;
      if (lastPos==str.npos) {
	tokens.push_back("");
	return;
      };
      // Find next "non-delimiter"
    }
    
  }

  Tokenize::TokenVec Tokenize::tokenVec() const {
    TokenVec v(size());
    Tokens::const_iterator it=  begin();
    TokenVec::iterator     jt=v.begin();
    while (it!=end()) {
      *(jt++) = *(it++);
    };
    return v;
  }

};
