#ifndef DOUBLETRIGGERNOISETESTRESULT_H
#define DOUBLETRIGGERNOISETESTRESULT_H

#include "SingleVariableTestResult.h"

using namespace std;

namespace SctData {
	
  /**
   * A derived class of TestResult, for result of a double trigger separated in time.
   * @author Alan Barr
   * @modified Bilge Demirkoz
   */
class DoubleTriggerNoiseTestResult : public TestResult {
public:
    DoubleTriggerNoiseTestResult() throw();
    ~DoubleTriggerNoiseTestResult() throw() {}
    /**
    Constructor.  
    */
    DoubleTriggerNoiseTestResult(const unsigned int runNumber, const string& moduleName) throw() ;
    virtual string getClassName() const throw();

    float getPedestalOccupancy(short unsigned ichip) const;
    void  setPedestalOccupancy(short unsigned ichip, float value);
    float getPeakOccupancy(short unsigned ichip) const;
    void setPeakOccupancy(short unsigned ichip, float value);
    float getPeakOccupancyBin(short unsigned ichip) const;
    void setPeakOccupancyBin(short unsigned ichip, float value);
    float getPeakRatio(short unsigned ichip) const;
    void setPeakRatio(short unsigned ichip, float value);
 private:
    vector<float> m_pedestal;
    vector<float> m_peak;
    vector<float> m_peakratio;
    vector<float> m_peakbin;
};
  
} // end of namespace SctData

#endif //#ifndef DOUBLETRIGGERNOISETESTRESULT_H
