#include "ChipCounterTestResultStreamer_v1.h"

using namespace Sct;

namespace SctData {
  namespace IO {
    
    /* READ NOTES ON STREAMERS AND VERSIONS BEFORE EDITING THIS FILE! */
    unsigned ChipCounterTestResultStreamer_v1::s_version=1;
    
    ChipCounterTestResultStreamer_v1::ChipCounterTestResultStreamer_v1() throw() {}
    
    bool ChipCounterTestResultStreamer_v1::inMap = IOManager::addToMap("SctData::ChipCounterTestResult",  auto_ptr<Streamer>(new ChipCounterTestResultStreamer_v1()));
    
    shared_ptr<Streamable> ChipCounterTestResultStreamer_v1::read(IStream& in, const IOManager& manager) const throw(LogicError, IoError){
      boost::shared_ptr<Streamable> ad (new ChipCounterTestResult());
      read(in, *ad, manager);
      return ad;
    }
    
    void ChipCounterTestResultStreamer_v1::write(OStream& out, const Streamable& ob, const IOManager& manager) const throw(LogicError, IoError) {
      //Let superclass do its work
      manager.writeImpl(out, ob, "SctData::TestResult");
    }
    
    void ChipCounterTestResultStreamer_v1::read(IStream& in, Streamable& ob, const IOManager& manager) const throw(LogicError, IoError) {
      manager.readImpl(in, ob, "SctData::TestResult");
    }	    
    
  }
}
