#ifndef SCTDATA_IO_MARKSPACERATIOTESTRESULTSTREAMER_H
#define SCTDATA_IO_MARKSPACERATIOTESTRESULTSTREAMER_H

#include "TestResultStreamer_v1.h"
#include "../MarkSpaceRatioTestResult.h"

namespace SctData {
namespace IO {

/**
 * This class allows publishing and refreshing of MarkSpaceRatioTestResult objects
 */
class MarkSpaceRatioTestResultStreamer_v1 : public Sct::Streamer {
public:
    //Streamer_v1 overrides
    virtual void write(OStream& out, const Streamable& ob, const IOManager& manager) const throw(LogicError, IoError);
    virtual shared_ptr<Streamable> read(IStream& in, const IOManager& manager) const throw(LogicError, IoError);
    virtual void read(IStream& in, Streamable& ob, const IOManager& manager) const throw(LogicError, IoError);   
    virtual unsigned getVersion() const throw() {return s_version;}
private:
    MarkSpaceRatioTestResultStreamer_v1() throw();
    static unsigned s_version;
    static bool inMap;
};
}
}

#endif // #ifndef SCTDATA_IO_MARKSPACERATIOTESTRESULTSTREAMER_H
