#ifndef SCTDATA_IO_OPESTREAMER_H
#define SCTDATA_IO_OPESTREAMER_H

#include "TestResultStreamer_v1.h"
class SctData::ChipOpeResult;
using SctData::ChipOpeResult;

namespace SctData {
namespace IO {

/**
 * This class allows publishing and refreshing of OpeResult objects to and from IS.
 * The published and refreshed elements are:
 * The (usually 12) OPE graphs.
 */
class OpeStreamer_v1 : public Sct::Streamer {
public:
    //Streamer_v1 overrides
    virtual void write(OStream& out, const Streamable& ob, const IOManager& manager) const throw(LogicError, IoError);
    virtual shared_ptr<Streamable> read(IStream& in, const IOManager& manager) const throw(LogicError, IoError);
    virtual void read(IStream& in, Streamable& ob, const IOManager& manager) const throw(LogicError, IoError);   
    void writeChipResult(OStream& out, const ChipOpeResult&, const IOManager& manager) const throw(LogicError, IoError) ;
    void readChipResult(IStream& in, ChipOpeResult&, const IOManager& manager) const throw(LogicError, IoError) ;
    virtual unsigned getVersion() const throw() {return s_version;}    
private:
    OpeStreamer_v1() throw();
    static unsigned s_version;
    static bool inMap;
};
} 
}
#endif // #ifndef SCTDATA_IO_OPESTREAMER_H
