#ifndef SCTDATA_IO_TH1DSTREAMER_H
#define SCTDATA_IO_TH1DSTREAMER_H

#include "Sct/Streamer.h"
#include "Sct/Exception.h"
#include "Sct/LogicErrors.h"
#include "Sct/IoExceptions.h"

using namespace Sct;

namespace SctData {
namespace IO {
/**
 * Allows serialization of root TH1D object to IS.
 */
class TH1DStreamer_v1 : public virtual Streamer {
public:
    //Streamer_v1 overrides
    virtual void write(OStream& out, const Streamable& ob, const IOManager& manager) const throw(LogicError, IoError);
    virtual void read(IStream& in, Streamable& ob, const IOManager& manager) const throw(LogicError, IoError);   
  
    virtual shared_ptr<Streamable> read(IStream& in, const IOManager& manager) const throw(LogicError, IoError);
    virtual unsigned getVersion() const throw() {return s_version;}
    
private:
    TH1DStreamer_v1() throw();
    static unsigned s_version;
    static bool inMap;		//True if in IOManager map
};

}
}
#endif // #ifndef SCTDATA_IO_TH1DSTREAMER_H
