#include "OpeResult.h"
#include "RawScanResult.h"
#include "Sct/SctParameters.h"

#include <TH1.h>
#include <iostream>

using namespace std;

namespace SctData {
    OpeResult::OpeResult(Sct::UniqueID id) :
      chipResult("OpeResult::chipResult"), m_uniqueID(id)
    {
      chipResult.resize(Sct::nChipModule);
    }

    OpeResult::OpeResult() :
      chipResult("OpeResult::chipResult"), m_uniqueID(0,0,""){
      chipResult.resize(Sct::nChipModule);
    }
    
    OpeResult::~OpeResult() {
    }
    
    string OpeResult::getClassName() const {
	return "SctData::OpeResult";
    }

    Sct::UniqueID OpeResult::getUniqueID() const{
      return m_uniqueID;
    }
    
    ChipOpeResult& ChipOpeResult::operator=(const ChipOpeResult& copyme){
	badmax=copyme.badmax; 
	threshold=copyme.threshold; 
	hist=copyme.hist;
	return *this;
    }
    
}

