#define USELIBRARY

#include <iostream>

#include "../TApi.h"

unsigned mid=2;

int main() {
  using namespace std;
  std::set_terminate(__gnu_cxx::__verbose_terminate_handler);

  // Start TApi
  TApi tapi;
  //tapi.setDebugOption("print_in_prim");
  tapi.initialiseAll(0);

  tapi.setDebugOption("diag");
  tapi.setDebugOption("diag2");
  tapi.setDebugOption("api_config_cache_check");
  tapi.setDebugOption("print_in_prim"); 
  // test set, send and get
  int variables[5] = {1,6,12,18,101};
  for (unsigned i=0;i<5;++i){
    std::cout << "=====================================================================" << std::endl;
    unsigned bank=i%3;
    std::cout << "modify variable " << variables[i] << " on bank " << bank << std::endl;
    tapi.modifyABCDVar(variables[i],bank);
    tapi.setABCDModules(bank);
    tapi.sendABCDModules(bank);
    tapi.getABCDModules(bank);
  }
  
  // test multi-set
  tapi.modifyABCDVar(6, 5); // modify trim
  std::list<UINT32> banks;
  banks.push_back(0);
  banks.push_back(2);
  tapi.setABCDModules(banks);

  tapi.getABCDModules(0);
  tapi.getABCDModules(1);
  tapi.getABCDModules(2);

  // test on-rod modification
  //tapi.setDebugOption("print_in_prim");
  tapi.modifyABCDVarROD(101, 1, 0); // MVAR_ACTIVE
  tapi.modifyABCDVarROD(18, 1, 0);  // ST_ACTIVE
  tapi.modifyABCDVarROD(12, 0, 0);  // ST_TRIM_RANGE
  tapi.modifyABCDVarROD(42, 0, 0);  // ST_QCAL
  tapi.modifyABCDVarROD(mid, 41, 1.2, 0); // ST_QTHR
  tapi.modifyABCDVarROD(mid, 8, 41, 1.3, 0); // ST_QTHR 
  tapi.modifyABCDVarROD(mid, 6, 12, 0);
  tapi.getABCDModules(0);

  // test copy
  std::list<UINT32> new_banks;
  new_banks.push_back(1); 
  tapi.copyABCDModules(0, new_banks);
  tapi.unsetDebugOption("print_in_prim");
  tapi.getABCDModules(1);
  std::cout << "DONE" << std::endl;
}
