
#ifndef SCT_SCTAPIIPC_CRATESTORE_H
#define SCT_SCTAPIIPC_CRATESTORE_H

namespace Sct {
  class CrateStore;
};

#include "Sct_SctApi/SctApi.hh"
#include "Sct/Addressing.h"
#include <list>
#include <map>
#include "boost/thread.hpp"

namespace Sct {

  class CrateStore {

  private:
    typedef Sct_SctApi::CrateIPC WorkerBase;

  public:
    typedef Sct_SctApi::CrateIPC_var Worker;
    typedef std::list<Worker> Workers;
    typedef std::list<Sct::UCID> UCIDList;

  public:
    void registerNewCrateController(Sct_SctApi::CrateIPC_ptr cc);
    Worker getCrate(const Sct::UCID &); 
    Worker getCrate(const Sct::Corba::UCID &);
    Worker getCrate(const Sct::URID &); //returns the crate containing URID
    Worker getCrate(const Sct::Corba::URID &); //returns the crate containing URID
    Workers & workers();
    unsigned int size() { return m_apis.size(); };
    UCIDList ucidList();

  private:
    boost::recursive_mutex m_apisMutex;
    Workers m_apis;
    typedef std::map<Sct::UCID, Workers::iterator> Map;
    Map m_mapUCIDToWorkersIterator;   
    
  };

};

#endif
