#include <boost/lexical_cast.hpp>

#include "Sct/SctNames.h"
#include "ScanMonitorServer.h"

#include "SctApi/ScanMonitor.h"

ScanMonitorServer::ScanMonitorServer(boost::shared_ptr<SctApi::ScanMonitor> mon) 
  : IPCNamedObject<POA_Sct_SctApi::ScanMonitor>(Sct::SctNames::getPartition(),
						getServerName().c_str()), 
    m_worker(mon) {

}

int ScanMonitorServer::nextNumber = 0;

std::string ScanMonitorServer::getServerName() {
  return "ScanMonitorServer" + boost::lexical_cast<std::string>(nextNumber++);
}

void ScanMonitorServer::newBin(CORBA::ULong prevTriggers, CORBA::UShort newBin) {
  worker().newBin(prevTriggers, newBin);
}

void ScanMonitorServer::finishScan() {
  worker().finishScan();
}
