

#include "ScanStatusManager.h"

namespace Sct {
  
  void ScanStatusManager::monitorThisScanner(CC & cc) {
    boost::recursive_mutex::scoped_lock lk(m_mutex);
    m_ccs.push_back(cc);
  };

  bool ScanStatusManager::scannersHaveFinished() {
    boost::recursive_mutex::scoped_lock lk(m_mutex);
    if (m_ccs.empty()) {
      return true;
    } else {
      this->removeCompleteScanners();
      return m_ccs.empty();
    };
  };

  void ScanStatusManager::removeCompleteScanners() {
    boost::recursive_mutex::scoped_lock lk(m_mutex);
    for(CCS::iterator it = m_ccs.begin();
	it != m_ccs.end(); // increment statement is in list body
	) {
      CC cc = *it;
      if (cc->hasFinishedScanning()) {
	// hey, this one has completed its scan, remove it!
	it = m_ccs.erase(it);
      } else {
	// fine, go on to the next one:
	++it;
      };
    };
  };
  
}

