#include "MarkSpaceRatioSummaryWriter.h"
#include "SctData/MarkSpaceRatioTestResult.h"
#include "SummaryManager.h"
#include <iomanip>

namespace SctData {
    namespace TestSummary{
	void MarkSpaceRatioSummaryWriter::write(const TestResult& t, std::ostream& out) const throw(Sct::IoError, Sct::LogicError)
	{
	    const MarkSpaceRatioTestResult& result  = dynamic_cast<const MarkSpaceRatioTestResult&>(t);
	    out << ios::fixed;
	    
	    out << "#\n%MarkSpaceRatioTest\n#\n";
	    out << "%Optimum\n";
	    out << setprecision(4) << result.getOptimum()<<endl;
	    SummaryWriter::write(t.getDefects(), out);
	}

	bool MarkSpaceRatioSummaryWriter::inMap = SummaryManager::instance().addWriter("SctData::MarkSpaceRatioTestResult", shared_ptr<SummaryWriter>(new MarkSpaceRatioSummaryWriter()));
    }
}
