#include "RxThresholdBasedOnConfigRegisterSummaryWriter.h"
#include "SctData/RxThresholdBasedOnConfigRegisterTestResult.h"
#include "SummaryManager.h"
#include <iomanip>

namespace SctData {
    namespace TestSummary{
	void RxThresholdBasedOnConfigRegisterSummaryWriter::write(const TestResult& t, std::ostream& out) const throw(Sct::IoError, Sct::LogicError)
	{
	    const RxThresholdBasedOnConfigRegisterTestResult& result  = dynamic_cast<const RxThresholdBasedOnConfigRegisterTestResult&>(t);
	    out << ios::fixed;
	    
	    out << "#\n%RxThresholdBasedOnConfigRegisterTest\n#\n";

	    out << endl;
	   for (unsigned ilink=0; ilink<nLinkModule; ++ilink){
             out << "# Link number " << ilink << "\n";
             out << "#\n";
             out << "# MinErrorFreeRxThresh " << setprecision(3) << result.getStreamResult(ilink).minErrorFreeRxThresh() << "\t"; 
             out << "MaxErrorFreeRxThresh " << setprecision(3) << result.getStreamResult(ilink).maxErrorFreeRxThresh() << "\t"; 
             out << "BestRxThresh " << setprecision(3) << result.getStreamResult(ilink).bestRxThresh() << "\n#\n"; 
	    }
	    out << "\n#\n#";
	    out << "\n#" << endl;

	    SummaryWriter::write(t.getDefects(), out);
	}

	bool RxThresholdBasedOnConfigRegisterSummaryWriter::inMap = SummaryManager::instance().addWriter("SctData::RxThresholdBasedOnConfigRegisterTestResult", shared_ptr<SummaryWriter>(new RxThresholdBasedOnConfigRegisterSummaryWriter()));
    }
}
