#include "TxCurrentSummaryWriter.h"
#include "SctData/TxCurrentTestResult.h"
#include "SummaryManager.h"
#include <iomanip>

namespace SctData {
    namespace TestSummary{
	void TxCurrentSummaryWriter::write(const TestResult& t, std::ostream& out) const throw(Sct::IoError, Sct::LogicError)
	{
	    const TxCurrentTestResult& result  = dynamic_cast<const TxCurrentTestResult&>(t);
	    out << ios::fixed;
	    
	    out << "#\n%TxCurrentTest\n#\n";

	    out << endl;
	   for (unsigned ilink=0; ilink<nLinkModule; ++ilink){
             out << "# Link number " << ilink << "\n";
             out << "#\n";
             out << "# MinErrorFreeTxCurrent " << setprecision(3) << result.getStreamResult(ilink).minErrorFreeTxCurrent() << "\t"; 
             out << "MaxErrorFreeTxCurrent " << setprecision(3) << result.getStreamResult(ilink).maxErrorFreeTxCurrent() << "\t"; 
             out << "BestTxCurrent " << setprecision(3) << result.getStreamResult(ilink).bestTxCurrent() << "\n#\n"; 
	    }
	    out << "\n#\n#";
	    out << "\n#" << endl;

	    SummaryWriter::write(t.getDefects(), out);
	}

	bool TxCurrentSummaryWriter::inMap = SummaryManager::instance().addWriter("SctData::TxCurrentTestResult", shared_ptr<SummaryWriter>(new TxCurrentSummaryWriter()));
    }
}
