
/**
 * This test checks for the minimum time for consecutive updates
 * Uses 1 ISServer and Several Objects
 * Any number of parameters are updated
 * The times are stored as miliseconds
 */

/// Standard C++ includes
#include <iostream>
#include <vector>
#include <string>
#include <fstream>

// Other standard C includes
extern "C" {
#include <unistd.h>
#include <sys/wait.h>
#include <sys/types.h>
#include <signal.h>
#include <sys/time.h>
};

// some cclasses needed to store data
#include "ipc/core.h"
#include <ipc/partition.h>
#include "cdi/cdiHandle.h"

// The objects to be stored
//#include "rc/Conditions.h"
//#include "rc/RunParams.h"

#include "AuxObjs.h"



// the number of data updates that must be made
#define MAX_UPD 1000
#define log std::cout << OWLTime()





int main(int argc, char**argv){
  
  IPCCore::init(argc, argv);
  
  setenv("TEST_NAME", __FILE__ ,1);  
  if (argc != 2 ){
    log << "::cdi_test -> Time interval not defined" << std::endl;
    return 1;
  }
  
  timeval t_start, t_end;
  
  std::ofstream fout("logs/cdi_test2.log");
  double interval;
  unsigned int tIntv = atoi(argv[1]);
  log << "::cdi_test2 -> Storing data with interval of " << tIntv << " microseconds" << std::endl;
  
  std::cout << OWLTime() << " :: cdi_test2 -> Initializing partition [be_test]!" << std::endl;
  
  fout << "------------------ Test1 START------------------------------" << std::endl;
  fout << "Initialize Online Environment : [" ;
  
  gettimeofday(&t_start,NULL);
  
//IPCPartition      p("part_localhost");
IPCPartition      p("be_test");
  
  if (p.isValid()) {
    std::cout << OWLTime() << " :: partition is valid!" << std::endl;
  }
  else
    std::cout << OWLTime() << " :: partition is NOT valid!" << std::endl;
  
  
  
  std::cout << OWLTime() << " :: cdi_test2 -> Initializing the dictionary!" << std::endl;
  
  ISInfoDictionary dict(p); 
  
  std::cout << OWLTime() << " :: cdi_test2 -> Initializing Conditions object!" << std::endl;
  //  Conditions c;
 

  gettimeofday(&t_end,NULL);
  interval = (double)(((double)t_end.tv_sec*1000+(double)t_end.tv_usec/1000)-((double)t_start.tv_sec*1000+(double)t_start.tv_usec/1000));
  fout << interval << "]" << std::endl;
  


  /* NEW PART GOES HERE
   */
     TestInfo1 obj1;
     TestInfo2 obj2;
     TestInfo3 obj3;
     TestInfo4 obj4;
     TestInfo5 obj5;
     TestInfo6 obj6;
     TestInfo7 obj7;
     TestInfo8 obj8;
     TestInfo9 obj9;
     TestInfo10 obj10;
     TestInfo11 obj11;
     TestInfo12 obj12;



//  TestInfo tmp1;

  obj1.c = 'a';
  obj1.uc = 'b';	
  obj1.i = 1;
  obj1.ui = 2;
  obj1.s = 3;
  obj1.us = 4;
  obj1.l = 5;	
  obj1.ul = 6;
  obj1.f = 7.7;
  obj1.d = 8.8;

  /*  
  strcpy(obj1.str, "RunParams");
  strcpy(obj1.cstr, "This is a constant string");	
  strcpy((char *)obj1.ustr, "This is a dinamic unsigned string");
  strcpy((char *)obj1.custr, "This is a constant unsigned string");
  */

// object 2
  obj2.c = 'a';
  obj2.uc = 'b';	
  obj2.i = 1;
  obj2.ui = 2;
  obj2.s = 3;
  obj2.us = 4;
  obj2.l = 5;	
  obj2.ul = 6;
  obj2.f = 7.7;
  obj2.d = 8.8;
  /*  strcpy(obj2.str, "RunParams");
  strcpy(obj2.cstr, "This is a constant string");	
  strcpy((char *)obj2.ustr, "This is a dinamic unsigned string");
  strcpy((char *)obj2.custr, "This is a constant unsigned string");
  */
// object 3
  obj3.c = 'a';
  obj3.uc = 'b';	
  obj3.i = 1;
  obj3.ui = 3;
  obj3.s = 3;
  obj3.us = 4;
  obj3.l = 5;	
  obj3.ul = 6;
  obj3.f = 7.7;
  obj3.d = 8.8;

  /*
  strcpy(obj3.str, "RunParams");
  strcpy(obj3.cstr, "This is a constant string");	
  strcpy((char *)obj3.ustr, "This is a dinamic unsigned string");
  strcpy((char *)obj3.custr, "This is a constant unsigned string");
  */
// object 4
  obj4.c = 'a';
  obj4.uc = 'b';	
  obj4.i = 1;
  obj4.ui = 4;
  obj4.s = 3;
  obj4.us = 4;
  obj4.l = 5;	
  obj4.ul = 6;
  obj4.f = 7.7;
  obj4.d = 8.8;
  /* strcpy(obj4.str, "RunParams");
  strcpy(obj4.cstr, "This is a constant string");	
  strcpy((char *)obj4.ustr, "This is a dinamic unsigned string");
  strcpy((char *)obj4.custr, "This is a constant unsigned string");
  */
// object 5
  obj5.c = 'a';
  obj5.uc = 'b';	
  obj5.i = 1;
  obj5.ui = 5;
  obj5.s = 3;
  obj5.us = 4;
  obj5.l = 5;	
  obj5.ul = 6;
  obj5.f = 7.7;
  obj5.d = 8.8;
  /*
 strcpy(obj5.str, "RunParams");
  strcpy(obj5.cstr, "This is a constant string");	
  strcpy((char *)obj5.ustr, "This is a dinamic unsigned string");
  strcpy((char *)obj5.custr, "This is a constant unsigned string");
  */
// object 6
  obj6.c = 'a';
  obj6.uc = 'b';	
  obj6.i = 1;
  obj6.ui = 6;
  obj6.s = 3;
  obj6.us = 4;
  obj6.l = 5;	
  obj6.ul = 6;
  obj6.f = 7.7;
  obj6.d = 8.8;
  /* strcpy(obj6.str, "RunParams");
  strcpy(obj6.cstr, "This is a constant string");	
  strcpy((char *)obj6.ustr, "This is a dinamic unsigned string");
  strcpy((char *)obj6.custr, "This is a constant unsigned string");
  */
// object 7
  obj7.c = 'a';
  obj7.uc = 'b';	
  obj7.i = 1;
  obj7.ui = 7;
  obj7.s = 3;
  obj7.us = 4;
  obj7.l = 5;	
  obj7.ul = 6;
  obj7.f = 7.7;
  obj7.d = 8.8;
  /* strcpy(obj7.str, "RunParams");
  strcpy(obj7.cstr, "This is a constant string");	
  strcpy((char *)obj7.ustr, "This is a dinamic unsigned string");
  strcpy((char *)obj7.custr, "This is a constant unsigned string");
  */
// object 8
  obj8.c = 'a';
  obj8.uc = 'b';	
  obj8.i = 1;
  obj8.ui = 8;
  obj8.s = 3;
  obj8.us = 4;
  obj8.l = 5;	
  obj8.ul = 6;
  obj8.f = 7.7;
  obj8.d = 8.8;
  /*  strcpy(obj8.str, "RunParams");
  strcpy(obj8.cstr, "This is a constant string");	
  strcpy((char *)obj8.ustr, "This is a dinamic unsigned string");
  strcpy((char *)obj8.custr, "This is a constant unsigned string");
  */
// object 9
  obj9.c = 'a';
  obj9.uc = 'b';	
  obj9.i = 1;
  obj9.ui = 9;
  obj9.s = 3;
  obj9.us = 4;
  obj9.l = 5;	
  obj9.ul = 6;
  obj9.f = 7.7;
  obj9.d = 8.8;

  /*
  strcpy(obj9.str, "RunParams");
  strcpy(obj9.cstr, "This is a constant string");	
  strcpy((char *)obj9.ustr, "This is a dinamic unsigned string");
  strcpy((char *)obj9.custr, "This is a constant unsigned string");
*/

// object 10
  obj10.c = 'a';
  obj10.uc = 'b';	
  obj10.i = 1;
  obj10.ui = 10;
  obj10.s = 3;
  obj10.us = 4;
  obj10.l = 5;	
  obj10.ul = 6;
  obj10.f = 7.7;
  obj10.d = 8.8;
  /* 
 strcpy(obj10.str, "RunParams");
  strcpy(obj10.cstr, "This is a constant string");	
  strcpy((char *)obj10.ustr, "This is a dinamic unsigned string");
  strcpy((char *)obj10.custr, "This is a constant unsigned string");
  */
// object 11
  obj11.c = 'a';
  obj11.uc = 'b';	
  obj11.i = 1;
  obj11.ui = 11;
  obj11.s = 3;
  obj11.us = 4;
  obj11.l = 5;	
  obj11.ul = 6;
  obj11.f = 7.7;
  obj11.d = 8.8;
  /* 
 strcpy(obj11.str, "RunParams");
  strcpy(obj11.cstr, "This is a constant string");	
  strcpy((char *)obj11.ustr, "This is a dinamic unsigned string");
  strcpy((char *)obj11.custr, "This is a constant unsigned string");
  */
// object 12
  obj12.c = 'a';
  obj12.uc = 'b';	
  obj12.i = 1;
  obj12.ui = 2;
  obj12.s = 3;
  obj12.us = 4;
  obj12.l = 5;	
  obj12.ul = 6;
  obj12.f = 7.7;
  obj12.d = 8.8;
  /* 
 strcpy(obj12.str, "RunParams");
  strcpy(obj12.cstr, "This is a constant string");	
  //strcpy((char *)obj12.ustr, "This is a dinamic unsigned string");
  //strcpy((char *)obj12.custr, "This is a constant unsigned string");
  obj12.ustr = "This is a dinamic unsigned string";
  obj12.cstr = "This is a constant unsigned string";
  */
						    

  std::vector<std::string> names;
  std::vector<ISInfo*> objs;
  objs.push_back(&obj1);
  objs.push_back(&obj2);
  objs.push_back(&obj3);
  objs.push_back(&obj4);
  objs.push_back(&obj5);
  objs.push_back(&obj6);
  objs.push_back(&obj7);
  objs.push_back(&obj8);
  objs.push_back(&obj9);
  objs.push_back(&obj10);
  objs.push_back(&obj11);
  objs.push_back(&obj12);

  for (unsigned int i=1; i<= 12; i++){
  std::ostringstream n;
  n << "RunParams.obj" << i;
  names.push_back(n.str().c_str());
  }
  
  std::cout << OWLTime() << " :: cdi_test2 -> Adding Information objects to the list!" << std::endl;
  fout << "Subscribing the object :["; 
  gettimeofday(&t_start,NULL);
  for (unsigned int i=1; i<=12; i++){
  dict.insert(names[i].c_str(),*(objs[i]));
  }
  gettimeofday(&t_end,NULL);
  interval = (double)(((double)t_end.tv_sec*1000+(double)t_end.tv_usec/1000)-((double)t_start.tv_sec*1000+(double)t_start.tv_usec/1000));
  fout << interval << "]" << std::endl;  
  sleep(30);
  /*
  */

   std::cout << OWLTime() << " ::cdi_test2 -> Starting to update the objects" << std::endl;
  //after having a nice beauty sleep we need to get to work again
  // let's start to update data
  

  timeval tt_s, tt_e;
  gettimeofday(&t_start,NULL);

  for (unsigned int i = 1; i <= MAX_UPD; i++) {
    for (unsigned int j = 1; j <=12; j++){
      (dynamic_cast<TestInfo1*>(objs[0]))->i += i;
      dynamic_cast<TestInfo2*>(objs[1])->i += i;
      dynamic_cast<TestInfo3*>(objs[2])->i += i;
      dynamic_cast<TestInfo4*>(objs[3])->i += i;
      dynamic_cast<TestInfo5*>(objs[4])->i += i;
      dynamic_cast<TestInfo6*>(objs[5])->i += i;
      dynamic_cast<TestInfo7*>(objs[6])->i += i;
      dynamic_cast<TestInfo8*>(objs[7])->i += i;
      dynamic_cast<TestInfo9*>(objs[8])->i += i;
      dynamic_cast<TestInfo10*>(objs[9])->i += i;
      fout << "Updating object [" << i << "| 0 ] : -> [";
      gettimeofday(&tt_s,NULL);
      dict.update(names[j].c_str(),*(objs[j]));
      gettimeofday(&tt_e,NULL);
      interval = (double)(((double)tt_e.tv_sec*1000+(double)tt_e.tv_usec/1000)-((double)tt_s.tv_sec*1000+(double)tt_s.tv_usec/1000));
      fout << interval << "]" << std::endl;
      // number of microseconds to sleep
      usleep(tIntv);
    }
  }
  gettimeofday(&t_end,NULL);
  interval = (double)(((double)t_end.tv_sec*1000+(double)t_end.tv_usec/1000)-((double)t_start.tv_sec*1000+(double)t_start.tv_usec/1000));
  fout << "Total update time: [" << interval << "]" << std::endl;
  fout << "-------------------------------------END OF TEST ----------------------------------";

  fout.close();
  log << "::cdi_test2 -> Test finished....exiting" << std::endl;
  return 0;
}
