/*
 * ExampleTestRequest.java
 *
 * Created on 31 July 2003, 17:07
 */

package TestGUI;
import Sct_CalibrationController.*;
import Sct_SctApi.*;
import GuiComponents.System.*;
import org.omg.CORBA.*;
import org.omg.CosNaming.*;
import org.omg.PortableServer.*;
import org.omg.PortableServer.POA;
import org.omg.CosNaming.NamingContextPackage.*;
import java.lang.String;

/**
 *
 * @author  palmer
 */
public class ExampleTestRequest extends TestRequestPOA{
    
    private SctApiIPC api;
    private java.lang.String fitAlg;
    private java.lang.String anaAlg;

    public void startTest(SctApiIPC api, StringHolder name, ShortHolder testVariable, IntHolder nScans, TestPointsHolder testPointsData) {
        System.out.println("startTest");
        this.api = api;
        name.value = "ExampleTest";
        testVariable.value = 0;
        nScans.value = 1;
        double [] pts = {10.};
        testPointsData.value = pts;
        System.out.println("startTest done");
    }
    
    public Sct_CalibrationController.ScanRequest getNextScan(int index) {
        System.out.println("getNextScan " + index);
        switch (index) {
            case 0:
                return SystemInterface.getInstance().getCalibrationController().getScanLibrary().defaultScan();
            default:
                return null;
        }
    }
        
    public void endTest() {
        System.out.println("endTest");
        api = null;
    }
	    
    public void setFitAlgorithm(java.lang.String s) {
        fitAlg = s;
    };

    public String getFitAlgorithm() {
        return fitAlg;
    };

    public void setAnalysisAlgorithm(java.lang.String s) {
	anaAlg = s;
    };

    public String getAnalysisAlgorithm() {
	return anaAlg;
    };

    public boolean canFeedback() {
        return false;
    }
    
}
