#include "ABCDModule_Test.h"
#include "../marshalling.h"
#include "sctConf/configXMLImpl.h"
#include <boost/test/unit_test.hpp>
#include <iostream>

ConfigurationXMLImpl* config;


void test1bin(){
  ABCDModule module;
  sctConf::ABCDModule copy1 = copyABCDModuleToCorba(module);
  size_t longs_in_config = sizeof(ABCDModule) / sizeof(UINT32);
  UINT32* p0 = (UINT32*) &module;
  UINT32* p1 = (UINT32*) &copy1;

  std::cout << "copyABCDModuleToCorba" << std::endl;
  for (unsigned i=1; i<longs_in_config; ++i){
    BOOST_CHECK_EQUAL(p0[i], p1[i]);
  }
}

void test2bin(){
  ABCDModule module;
  sctConf::ABCDModule copy1 = copyABCDModuleToCorba(module);
  ABCDModule copy2 = copyCorbaToABCDModule(copy1);

  size_t longs_in_config = sizeof(ABCDModule) / sizeof(UINT32);
  UINT32* p0 = (UINT32*) &module;
  UINT32* p2 = (UINT32*) &copy2;

  std::cout << "copyABCDModuleToCorba" << std::endl;
  for (unsigned i=1; i<longs_in_config; ++i){
    BOOST_CHECK_EQUAL(p0[i], p2[i]);
  }
}

void test_ascii(){
  std::cout << "check ascii" << std::endl;
  ABCDModule module;
  sctConf::ABCDModule copy1 = copyABCDModuleToCorba(module);
  ABCDModule copy2 = copyCorbaToABCDModule(copy1);
  std::string string0=config->printModuleConfig(module);
  std::string string2=config->printModuleConfig(copy2);
  BOOST_CHECK_EQUAL(config->printModuleConfig(module), config->printModuleConfig(copy2));
}

ABCDModule_Test::ABCDModule_Test() {
  config=new ConfigurationXMLImpl();
  add(BOOST_TEST_CASE(&test1bin));
  add(BOOST_TEST_CASE(&test2bin));
  add(BOOST_TEST_CASE(&test_ascii));
}
