/*
 * GuiTable.java
 *
 *
 */

package DisplayGUI;
import javax.swing.JTable;
import javax.swing.event.*;
import javax.swing.ListSelectionModel;
import javax.swing.table.TableModel;
import javax.swing.event.ListSelectionListener;
import javax.swing.event.ListSelectionEvent;
import java.util.Hashtable;
import java.util.Collections;
import java.util.Vector;

/**
 *
 * @author  robinson
 */
public class GuiTable implements displayParams,TableModelListener {
    gui guiControl;
    guiTableAdapter resultTable = new guiTableAdapter();
    JTable table = new JTable();
    Vector objectNames = new Vector();
    ListSelectionModel rowSM;
    String title;
    public javax.swing.JLabel tableTitle;
    boolean selectionListenerIsActive=true;

public GuiTable(gui parent) {
	guiControl=parent;
	title=null;
	tableTitle=new javax.swing.JLabel("");
	resultTable = new guiTableAdapter();
      table = new JTable(resultTable) {
		public String getToolTipText(java.awt.event.MouseEvent e) {
	       	TableModel model = getModel();
            int rowSelect = this.rowAtPoint(new java.awt.Point(e.getX(),e.getY()));
	       	if(rowSelect<0) return null;
            String sn = (String)model.getValueAt(rowSelect,0);
	       	if(sn.matches("\\d{14}")) {
				ConfigurationInterface config = ConfigurationInterface.getInstance();
	       	 	ModuleCell thisCell = config.getModuleCell(sn);
                StringBuffer infoString = new StringBuffer(sn+" - ");
	         	infoString.append("MUR "+thisCell.getMUR()+", Row "+thisCell.getRow()+", Position "+thisCell.getPosition());
	         	infoString.append(", ROD Crate "+config.getSNInfo(sn,SNInfo.ROD_CRATE)+", ROD Slot "+config.getSNInfo(sn,SNInfo.ROD_NUMBER)+", ROD Channel "+config.getSNInfo(sn,SNInfo.ROD_CHANNEL));
	         	infoString.append(", PS Crate "+config.getSNInfo(sn,SNInfo.DCS_CRATE)+", PS Channel "+config.getSNInfo(sn,SNInfo.DCS_CHANNEL));
		 		return infoString.toString();
		 		}
               	else return null;
		 	}
             };
      rowSM = table.getSelectionModel();
      table.setFont(tableFont);

    }

public JTable getTable() {
	return table;
	}
public void setSelectedSerialNo(String sn, boolean changeSelection) {
        int is = rowSM.getMinSelectionIndex();
        if(is!=-1 && !changeSelection) return;
        for(int i=0;i<resultTable.getRowCount();i++) {
           if(sn.equals((String)resultTable.getValueAt(i,0))) {
                       rowSM.setSelectionInterval(i,i);
                       break;
                       }
           }
       }

public int getRowCount() {
	return resultTable.getRowCount();
	}

public String getSelectedObject() {
        if(objectNames==null) return null;
        int selectedRow = rowSM.getMinSelectionIndex();
        if(selectedRow==-1 || objectNames.size()==0 || selectedRow>objectNames.size()-1) return null;
        return (String)objectNames.elementAt(selectedRow);
        }

public int getSelectedIndex() {
	return rowSM.getMinSelectionIndex();
	}

public void setTableContent(Vector data) {
	objectNames=data;
	}
public Vector getObjectNames() {
	return objectNames;
	}
public void addTableObject(String theObjectName) {
           if(objectNames==null) return;
           if(!objectNames.contains(theObjectName)) objectNames.addElement(theObjectName);
           }

public void removeTableObject(String theObjectName) {
           if(objectNames.contains(theObjectName)) objectNames.removeElement(theObjectName);
	     }

public void tableChanged(javax.swing.event.TableModelEvent e) {
        updateTitle();
    }

public void updateTitle() {
      tableTitle.setText((title==null) ? "" : title+" : "+Integer.toString(resultTable.getRowCount()));
	}

public void setTitle(String title) {
	this.title=title;
	updateTitle();
	}
public void refresh(Vector newObjectNames, Vector tableContents, String title) {
	objectNames = new Vector(newObjectNames);
	refresh(tableContents,title);
      }
public void refresh(Vector tableContents, String title) {
      selectionListenerIsActive=false;
      int oldSelect = rowSM.getMinSelectionIndex();
      resultTable.reTable(tableContents);
      if(oldSelect>=0 && oldSelect<=tableContents.size()-1) rowSM.setSelectionInterval(oldSelect,oldSelect);
      selectionListenerIsActive=true;
      javax.swing.table.TableColumn column = table.getColumnModel().getColumn(0);
      column.setPreferredWidth(110);
      setTitle(title);
      }
public void refresh(Vector tableContents, int rowSelection) {
      selectionListenerIsActive=false;
	resultTable.reTable(tableContents);
      javax.swing.table.TableColumn column = table.getColumnModel().getColumn(0);
      column.setPreferredWidth(110);
      selectionListenerIsActive=true;
      if(rowSelection>=0 && rowSelection<=tableContents.size()-1) rowSM.setSelectionInterval(rowSelection,rowSelection);
      }
}
