/*
 * TablesDisplayPane.java
 *
 * Created on 23 June 2003, 15:43
 */

package DisplayGUI;
import javax.swing.event.*;
import java.util.Vector;
import GuiComponents.System.*;
/**
 *
 * @author  robinson
 */
public class TablesDisplayPane extends javax.swing.JPanel implements TestDataInfo,displayParams {
    gui guiControl;
    public javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private GuiComponents.System.ISInterface is;

    public ResultsTable resultsTable;
    public IndexTable indexTable;

    public static int INDEX_TABLE=0;
    public static int RESULTS_TABLE=1;


    public TablesDisplayPane(gui parent) {
        guiControl=parent;
	  indexTable = new IndexTable(guiControl);
	  resultsTable = new ResultsTable(guiControl);

        initComponents();

        setBorder(new javax.swing.border.TitledBorder(null, "Data", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Arial", 0, 11), new java.awt.Color(0, 0, 153)));

    }

    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        jScrollPane1 = new javax.swing.JScrollPane(indexTable.getTable());
        jScrollPane2 = new javax.swing.JScrollPane(resultsTable.getTable());

        setLayout(new java.awt.GridBagLayout());

        setBackground(new java.awt.Color(255, 255, 255));
        jScrollPane1.setBackground(new java.awt.Color(255, 255, 255));
        jScrollPane1.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.LOWERED));
        jScrollPane1.setMinimumSize(new java.awt.Dimension(300, 150));
        jScrollPane1.setPreferredSize(new java.awt.Dimension(300, 200));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.ipadx = 2;
        gridBagConstraints.ipady = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTH;
        gridBagConstraints.weighty = 0.4;
        add(jScrollPane1, gridBagConstraints);

        indexTable.tableTitle.setFont(new java.awt.Font("Arial", 0, 12));
        indexTable.tableTitle.setForeground(new java.awt.Color(51, 0, 153));
        indexTable.tableTitle.setText("Index Table");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weighty = 0.05;
        add(indexTable.tableTitle, gridBagConstraints);

        jScrollPane2.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.LOWERED));
        jScrollPane2.setMinimumSize(new java.awt.Dimension(300, 150));
        jScrollPane2.setPreferredSize(new java.awt.Dimension(300, 200));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTH;
        gridBagConstraints.weighty = 0.4;
        add(jScrollPane2, gridBagConstraints);

        resultsTable.tableTitle.setFont(new java.awt.Font("Arial", 0, 12));
        resultsTable.tableTitle.setForeground(new java.awt.Color(51, 0, 153));
        resultsTable.tableTitle.setText("Results Table");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weighty = 0.05;
        add(resultsTable.tableTitle, gridBagConstraints);

//        jScrollPane1.addMouseListener(new tables0MouseAdapter());  // popup menu on second table only
//        jScrollPane2.addMouseListener(new tables1MouseAdapter());  // popup menu on second table only

    }
  
    public java.awt.Insets getInsets() {
        return new java.awt.Insets(10,10,10, 10);
    }


    public void refresh(Vector[] tableContents, int table0RowSelect, int table1RowSelect) {

	  indexTable.refresh(tableContents[INDEX_TABLE],table0RowSelect);
	  resultsTable.refresh(tableContents[RESULTS_TABLE],table1RowSelect);

        }



    public String getSelectedObject() {
       return resultsTable.getSelectedObject();
       }


	public TestSelection getTestSelection() {
		return indexTable.getTestSelection();
		}
	public IVTestSelection getIVTestSelection() {
		return indexTable.getIVTestSelection();
		}
	public String getTestControlObjectName() {
		return indexTable.getTestControlObjectName();
		}
	public Vector getTestControlObjectNames() {
		return indexTable.getObjectNames();
		}
	public int getSelectedTest() {
		return indexTable.getSelectedTest();
		}

    public void listISObjects(ModuleCell thisCell) {
       String title = "No module selected";

       if(thisCell!=null) {
            title =guiControl.selectorPane.getDisplayParameter()+" for "+thisCell.getSerialNo();
            resultsTable.refresh(resultsTable.getISTableList(thisCell),title);
            }
	 else resultsTable.setTitle(title);
        }


     public void listTestResults() {


	  ConfigurationInterface config = ConfigurationInterface.getInstance();
      int status = guiControl.displayStatus.getStatus();
      int displayParameter = guiControl.selectorPane.getDisplayParameterIndex();
	  String displayParamName = guiControl.selectorPane.getDisplayParameter();
        String testParameter = (displayParamName!=null && displayParamName.matches(".*DCS.*")) ? guiControl.selectorPane.getOption() : displayParamName;
        if(status==DisplayStatus.IV_DATA) {
              if(getIVTestSelection()==null) return;
              switch(displayParameter) {
                case 1:
                 testParameter = guiControl.selectorPane.getIVParameter();
                 break;
                case 2:
                 testParameter = guiControl.selectorPane.getOption();
                 break;
                default:
                 testParameter = guiControl.selectorPane.getDisplayParameter();
                }
              }
        else if((status!=DisplayStatus.DCS_DATA && status!=DisplayStatus.PROBE_DATA && status!=DisplayStatus.MODULE_GROUP_SELECTION) && getTestSelection()==null) return;

        java.util.Set moduleList = config.getSerialNumberList(guiControl.selectorPane.getViewCategoryIndex(),guiControl.selectorPane.getViewIndex());
        int index = guiControl.selectorPane.getMouseClickIndex();
        Vector theLine = new Vector();
        Vector table = new Vector();
        Vector objectsVector = new Vector();
        theLine.addElement("Serial No");
        switch(status) {
           case DisplayStatus.SCTDB_DATA:
            theLine.addElement("Location");
            theLine.addElement("Date");
            break;
           case DisplayStatus.SCTDB_RODDAQ_DATA:
              theLine.addElement("Date");
             break;
           default:
           }
        theLine.addElement(testParameter);
        table.addElement(theLine);

        SummaryReader.Test testResult;

        for (java.util.Iterator i = moduleList.iterator(); i.hasNext(); ) {
           String thisSN=(String)i.next();

                 ModuleCell thisCell = config.getModuleCell(thisSN);
                 theLine=new Vector();
                 theLine.addElement(thisSN);

                 switch(status) {
                   case DisplayStatus.SCTDB_DATA:
                     if(getTestSelection().getSCTDBObjectHeader()==null) continue;
                     testResult = guiControl.isInterface.getSCTDBTest(getTestSelection().getSCTDBObjectHeader()+thisSN);
                     if(testResult==null) {
                       theLine.addElement(" - ");
                       theLine.addElement(" - ");
                       }
                     else {
                       theLine.addElement(testResult.getDAQInfo().get(SummaryReader.DAQInfo.LOCATION));
                       theLine.addElement(testResult.getDAQInfo().get(SummaryReader.DAQInfo.DATE));
                       }
                     break;
                   case DisplayStatus.SCTDB_RODDAQ_DATA:
                     testResult = guiControl.isInterface.getSCTDBTest(getTestSelection().getSCTDBRodDaqObjectHeader()+thisSN);
                     if(testResult==null) theLine.addElement(" - ");
                     else theLine.addElement(testResult.getDAQInfo().get(SummaryReader.DAQInfo.DATE));
                     break;
                   default:
                   }

                 ColorScale thisColorScale;
                 if((thisColorScale = guiControl.colorScalePane.getColorScale())!=null) theLine.addElement(thisColorScale.getLabel(thisCell.getData()));
                 else theLine.addElement("No Data");
                 table.addElement(theLine);
                 }
          String title = (status==DisplayStatus.TEST_DATA && guiControl.displayPane.getDisplayOption()==2) ? testParameter+" Comparisons" : testParameter+" Results ";
          resultsTable.refresh(objectsVector,table,title);
         }   

    public void updateTables(boolean keepSelections) {
         changeTables(keepSelections);
         }
    public void updateTables() {
         changeTables(!guiControl.guiMenus.autoSelectMode);
         }

    private void changeTables(boolean keepSelections) {

	  ConfigurationInterface config = ConfigurationInterface.getInstance();

      indexTable.setNullTestSelection();

      Vector theLine = new Vector();
      int table0Select=-1;
      int table1Select=-1;
      String selectedObject0 = indexTable.getSelectedObject();
      String selectedObject1 = resultsTable.getSelectedObject();
      if(keepSelections) table0Select = indexTable.getSelectedIndex();
      table1Select = resultsTable.getSelectedIndex();

      String title0=null;
      String title1=null;
      Vector[] tableContents = new Vector[2];
      tableContents[INDEX_TABLE] = new Vector();
      tableContents[RESULTS_TABLE] = new Vector();

      int previousSelection = keepSelections ? indexTable.getSelectedTest() : -1;

      int view = guiControl.selectorPane.getViewIndex();
      int displayStatus = guiControl.displayStatus.getStatus();
	  int parameter = guiControl.selectorPane.getDisplayParameterIndex();

      switch(displayStatus) {
          case DisplayStatus.MODULE_GROUP_SELECTION :
	       if(parameter==0) {
             	title0 = "ModuleGroups";
             	String option = guiControl.selectorPane.getOption();
             	title1 = (option!=null) ? option+" modules" : null;
             	// results table
             	theLine.addElement("Serial No");
             	String title = (view<4) ? "Row" : "Quadrant";
             	theLine.addElement(title);
             	theLine.addElement("Posn");
             	theLine.addElement("MUR");
             	tableContents[RESULTS_TABLE].addElement(theLine);
             	// summary table
             	theLine = new Vector();
		 	switch(parameter) {
		 		case -1:
					break;
				case 0:
             			theLine.addElement("Group");
             			theLine.addElement("# Modules");
					break;
				default:
					theLine.addElement(guiControl.selectorPane.getDisplayParameter());
					theLine.addElement("Count");
				}
             	tableContents[INDEX_TABLE].addElement(theLine);

             	java.util.Set moduleList = config.getSerialNumberList(guiControl.selectorPane.getViewCategoryIndex(),guiControl.selectorPane.getViewIndex());
             	java.util.Map groupCounts = new java.util.HashMap();

             	int selectedGroup = guiControl.selectorPane.getMouseClickIndex();
             	table0Select = selectedGroup;
             	for (java.util.Iterator i = moduleList.iterator(); i.hasNext(); ) {
               		String thisSN=(String)i.next();
               		ModuleCell thisCell = config.getModuleCell(thisSN);
               		int thisGroup = thisCell.getModuleGroup();
               		if(thisGroup<0) continue;

               		Integer iThisGroup = new Integer(thisGroup);
               		Integer c;
               		if((c = (Integer)groupCounts.get(iThisGroup))==null) groupCounts.put(iThisGroup,new Integer(1));
               		else groupCounts.put(iThisGroup,new Integer(c.intValue()+1));

               		if(thisGroup!=selectedGroup) continue;
               		theLine = new Vector();
               		theLine.addElement(thisSN);
               		if(view<4) {
                    		theLine.addElement(Integer.toString(thisCell.getRow()));
                    		theLine.addElement(Integer.toString(thisCell.getPosition()));
                    	}
              	 else {
                    	theLine.addElement(thisCell.getQuadrant());
                    	theLine.addElement(thisCell.getEndCapPosition());
                    	}

               	theLine.addElement(Integer.toString(thisCell.getMUR()));
               	tableContents[RESULTS_TABLE].addElement(theLine);
               	}
               	for(int i=0;i<8;i++) {
                  	theLine = new Vector();
                  	theLine.addElement("ModuleGroup "+i);
                  	Integer c;
                  	if((c=(Integer)groupCounts.get(new Integer(i)))==null) theLine.addElement(new Integer(0));
                  	else theLine.addElement(c);
                  	tableContents[INDEX_TABLE].addElement(theLine);
                  	}
			}
		else { // BOC parameter
			table0Select=-1;
			table1Select=-1;
			title0="BOC Configuration";
			String pName = guiControl.selectorPane.getDisplayParameter();
			title1=(pName!=null) ? pName : null;
			theLine=new Vector();
			theLine.addElement("Data");
			theLine.addElement("Count");
			tableContents[INDEX_TABLE].addElement(theLine);
			}

             break;
           case DisplayStatus.IS_MONITOR:
               title0 = "Tests";
               title1 = guiControl.selectorPane.getDisplayParameter();
               tableContents[RESULTS_TABLE] = resultsTable.getISTableList(guiControl.displayPane.getLastClickedCell());
               tableContents[INDEX_TABLE] = indexTable.getTestTableList();
               break;
           case DisplayStatus.IV_DATA:
               title0 = "IV scans";
               title1 = "IV Data";
               tableContents[INDEX_TABLE] = indexTable.getIVScanList();
               theLine = new Vector();
               theLine.addElement("Serial No");
               theLine.addElement(guiControl.selectorPane.getIVParameter());
               tableContents[RESULTS_TABLE].addElement(theLine);
               break;
           case DisplayStatus.TEST_DATA:
           case DisplayStatus.SCTDB_DATA:
           case DisplayStatus.SCTDB_RODDAQ_DATA:
               int testType = guiControl.isInterface.getListFilterIndex();
               title0 = (testType==-1) ? "Number of Tests " : "Number of "+testMenuNames[testType]+" Tests ";
               String testParameter = guiControl.selectorPane.getDisplayParameter();
               title1 = testParameter+ " Results";
               theLine = new Vector();
               theLine.addElement("Serial No");
               theLine.addElement(testParameter);
               tableContents[RESULTS_TABLE].addElement(theLine);
               tableContents[INDEX_TABLE]=indexTable.getTestTableList();
               if(tableContents[INDEX_TABLE].size()>1) {
                     if(previousSelection<=tableContents[INDEX_TABLE].size()-2 && previousSelection>=0) table0Select=previousSelection;
                     else table0Select=tableContents[INDEX_TABLE].size()-2; // remember titles!!
                     }

               break;
           case DisplayStatus.DCS_DATA:
               table0Select=-1;
               table1Select=-1;
               title0 = "Server Info";
               title1 = guiControl.selectorPane.getDisplayParameter()+ " Data";
               theLine = new Vector();
               theLine.addElement("Serial No");
               theLine.addElement(guiControl.selectorPane.getDisplayParameter());
               tableContents[RESULTS_TABLE].addElement(theLine);
               theLine = new Vector();
               theLine.addElement("Server");
               theLine.addElement("Last Update");
               tableContents[INDEX_TABLE].addElement(theLine);
               theLine = new Vector();
               theLine.addElement(Preferences.PreferencesInterface.getInstance().getPreference(Preferences.PreferencesInterface.DCS_SERVER_NAME));
               theLine.addElement(guiControl.isInterface.isRequestBuffer.getLastUpdateTime());
               tableContents[INDEX_TABLE].addElement(theLine);
               break;
           case DisplayStatus.PROBE_DATA:
               table0Select=-1;
               table1Select=-1;
               title0 = "Module Probe Counts";
               title1 = "Module Probe Data";
               theLine = new Vector();
               theLine.addElement("Serial No");
               theLine.addElement(guiControl.selectorPane.getOption());
               tableContents[RESULTS_TABLE].addElement(theLine);
               tableContents[INDEX_TABLE] = SctApiInfo.getInstance().getCountVector();
               break;
           default:
	       guiControl.displayPane.refreshDisplay();
               return;
              }
        boolean dontSelect = (displayStatus==DisplayStatus.DCS_DATA || displayStatus==DisplayStatus.PROBE_DATA);

        if(table0Select==-1 && tableContents[INDEX_TABLE].size()>1 && !dontSelect) table0Select=tableContents[INDEX_TABLE].size()-2; // remember titles!!
        if(table1Select==-1 && tableContents[RESULTS_TABLE].size()>1 && !dontSelect) table1Select=tableContents[RESULTS_TABLE].size()-2; // remember titles!!
	  refresh(tableContents,table0Select,table1Select);
	  indexTable.setTitle(title0);
	  resultsTable.setTitle(title1);

        if(indexTable.getSelectedTest()==-1) {  // no test now selected, so need to update display manually (otherwise selection listener would do it)
//              guiControl.isInterface.setTestFilter(null);
              indexTable.setNullTestSelection();
              guiControl.displayPane.setDisplayColors();
              guiControl.displayPane.refreshDisplay();
              guiControl.selectorPane.initParamList();
               }
// for DCS, there is no selection in the test table that will fill the bottom table, so do it here manually
        if(displayStatus==DisplayStatus.DCS_DATA || displayStatus==DisplayStatus.PROBE_DATA || (displayStatus==DisplayStatus.MODULE_GROUP_SELECTION && parameter>0)) {
//              indexTable.setNullTestSelection();
//              guiControl.displayPane.setDisplayColors();
//              guiControl.displayPane.refreshDisplay();
              listTestResults();
              }
    }

    public void setTestTable(Vector ISTests) {
           indexTable.setTableContent(ISTests);
           updateTables(true);
           }
    public void addNewTest(String theObjectName) {
           indexTable.addTableObject(theObjectName);
           }
    public void removeTest(String theObjectName) {
	     indexTable.removeTableObject(theObjectName);
           updateTables(true);
           }


    public void checkForRetrievedObjects() {
         checkForRetrievedObjects(-1);
         }

    public void checkForRetrievedObjects(int serverIndex) {
    	   TestSelection testSelection = getTestSelection();
         if(testSelection==null || !testSelection.isRetrievedData()) return;
         if(serverIndex==-1) serverIndex = guiControl.selectorPane.getDisplayParameterIndex();
         if(guiControl.isInterface.isCounter.archivedObjectsRetrievedOk(serverIndex,testSelection.getRunScanRegex())) return;
         System.out.println("SctGUI - Retrieving archived data files...");
         String oName;
         switch(serverIndex) {
                          case 1:
                              oName = "SctData::FitScanResult";
                              break;
                          case 2:
                              oName = "SctData::*TestResult";
                              break;
                          default:
                              oName = "SctData::RawScanResult";
                              }
                      
         try {
//           System.out.println("retrieve("+testSelection.getRunNo()+","+testSelection.getScanNo()+","+oName+","+"*"+")");
           ArchivingServiceI.ArchivingServiceInterface a = SystemInterface.getInstance().getArchivingService();
           int scan=testSelection.getScanNo();
           if(serverIndex==2) a.retrieve(Integer.toString(testSelection.getRunNo()),Integer.toString(scan),oName,"*");
           else {
               for(int i = 0;i<testSelection.getNoScans();i++) a.retrieve(Integer.toString(testSelection.getRunNo()),Integer.toString(scan+i),oName,"*");
               }
         }catch(Exception e2) {System.err.println("SctGUI::TablesDisplayPane - Exception from retrieving from ArchiveService: "+e2.toString());}

              }



    
}

