package guiUtilities;

import javax.swing.JOptionPane;
import javax.swing.JDialog;
import javax.swing.JTextField;
import java.beans.*; //property change stuff
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;


public class ChoiceDialog extends JDialog
                   implements PropertyChangeListener {

    private JList objectJList;
    private Object[] objectList;

    private JOptionPane optionPane;

    private String btnString1 = "Enter";
    private String btnString2 = "Cancel";
    Object[] selectedObjects=null;

    /**
     * Returns null if the typed string was invalid;
     * otherwise, returns the string as the user entered it.
     */
    public Object[] getSelectedObjects() {
        return selectedObjects;
    }

    /** Creates the reusable dialog. */
    public ChoiceDialog(Frame aFrame, String title, int width, int height, Object[] objectList, boolean canMultipleSelect) {
        super(aFrame, true);
	
	this.objectList=objectList;

        setTitle(title);

	objectJList = new JList(objectList);
 //       objectJList.setFont(displayScaleFont);
        if(canMultipleSelect) objectJList.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
	else objectJList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
	JScrollPane optionsScrollPane = new JScrollPane(objectJList);
        optionsScrollPane.setMinimumSize(new Dimension(width, height));

        //Create an array of the text and components to be displayed.
        String msgString1 = title;
        Object[] array = {msgString1, optionsScrollPane};

        //Create an array specifying the number of dialog buttons
        //and their text.
        Object[] options = {btnString1, btnString2};

        //Create the JOptionPane.
        optionPane = new JOptionPane(array,
                                    JOptionPane.PLAIN_MESSAGE,
                                    JOptionPane.YES_NO_OPTION,
                                    null,
                                    options,
                                    options[0]);

        //Make this dialog display it.
        setContentPane(optionPane);

        //Handle window closing correctly.
        setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
        addWindowListener(new WindowAdapter() {
                public void windowClosing(WindowEvent we) {
                /*
                 * Instead of directly closing the window,
                 * we're going to change the JOptionPane's
                 * value property.
                 */
                    optionPane.setValue(new Integer(
                                        JOptionPane.CLOSED_OPTION));
            }
        });

        //Ensure the text field always gets the first focus.
  //      addComponentListener(new ComponentAdapter() {
  //          public void componentShown(ComponentEvent ce) {
  //              textField.requestFocusInWindow();
  //          }
  //      });

        //Register an event handler that puts the text into the option pane.
  //      textField.addActionListener(this);

        //Register an event handler that reacts to option pane state changes.
        optionPane.addPropertyChangeListener(this);
    }

    /** This method handles events for the text field. */
    public void actionPerformed(ActionEvent e) {
        optionPane.setValue(btnString1);
    }

    /** This method reacts to state changes in the option pane. */
    public void propertyChange(PropertyChangeEvent e) {
        String prop = e.getPropertyName();

        if (isVisible()
         && (e.getSource() == optionPane)
         && (JOptionPane.VALUE_PROPERTY.equals(prop) ||
             JOptionPane.INPUT_VALUE_PROPERTY.equals(prop))) {
            Object value = optionPane.getValue();

            if (value == JOptionPane.UNINITIALIZED_VALUE) {
                //ignore reset
                return;
            }

            //Reset the JOptionPane's value.
            //If you don't do this, then if the user
            //presses the same button next time, no
            //property change event will be fired.
            optionPane.setValue(
                    JOptionPane.UNINITIALIZED_VALUE);

            if (btnString1.equals(value)) {
	        selectedObjects = objectJList.getSelectedValues();
                clearAndHide();
                }
	    else if(btnString2.equals(value)) {
	       clearAndHide();
	       }
	}
    }

    /** This method clears the dialog and hides it. */
    public void clearAndHide() {
        setVisible(false);
    }
}
