#!/usr/bin/perl -Tw
use strict;
use CGI qw(param);
use CGI::Carp qw(fatalsToBrowser);
use Fcntl;

use lib "/userdisk/daquser/perllibs2";
use sctroddaqtests;
use webconfig;


################################################################# Do not edit anything after this line
my $DEBUG=0;

my @errors=();

my %comments = ();

my $totalwidth=600;

my ($minute, $hour, $day, $month, $year) = (localtime)[1,2,3,4,5];
$year += 1900;
$month += 1;
$minute = "0" . $minute if ($minute<10);
$hour = "0" . $hour if ($hour<10);
$month = "0" . $month if ($month<10);
$day = "0" . $day if ($day<10);
my $shortyear = substr($year,2,3);
my $theDate = "$day/$month/$shortyear";
my $thelongDate = "$day/$month/$year";
my $datestamp = "$hour:$minute on $day/$month/$year";
my $scriptname = $ENV{'SCRIPT_NAME'};  # name of this script for links etc


print "Content-type: text/html\n\n";

getConfiguration();   # from webconfig.pm

my $serialno = param("serialno") ? param("serialno") : "";
my $reqSN = param("reqSN") ? param("reqSN") : "";
if(param("newSN")) {$serialno=param("reqSN");}
my $ff = param("ff") ? param("ff") : "";
my $user = param("user") ? param("user") : "";
my $comment = param("comment") ? param("comment") : "";
my $index = param("index") ? param("index") : "0";
my $pff = "SCTcomments";

#untaint
unless ( $comment =~ /^([^<>\$]*)$/ ) {
  push(@errors,"Illegal characters are present in your comment(s).");
  push(@errors,"These might include characters like '$', '>' etc.");
  push(@errors,"Please remove them and try again.");
  }
$comment = $1;

unless ($user =~/^([^<>\$]*)$/) {
  push(@errors,"Illegal characters are present in your user name.");
  push(@errors,"These might include characters like '$', '>' etc.");
  push(@errors,"Please remove them and try again.");
  }
$user = $1;



if($DEBUG) {
print "serial no=$serialno <br>\n";
print "ff=$ff <br>\n";
print "user=$user <br>\n";
print "comment=$comment <br>\n";
print "index=$index <br>\n";
}

my $lastsite =  $ENV{'HTTP_REFERER'};

my $startedTableList=0;
my @modules=();

# process parameters

SWITCH: {
    &printHeader() && do {last SWITCH;};
    
    param("allcomments") && do {
       print "<b>All Modules Comments entered so far:</b><br><br>";
       opendir(HDATA,"${lookupDir}ModuleComments") || printError("Cant open directory: $!");
       while(my $filename = readdir(HDATA)) {
         if($filename=~/(\d{14}).txt/) {push(@modules,$1);}
         }
       closedir(HDATA);

       foreach my $sn (sort @modules) {
           &getComments($sn);
           &printAllComments($sn);
           }

      if($startedTableList>0) {print "</table>";}
      else {print "&gt; There are no comments entered yet for any module.<br>\n";}
      
      last SWITCH;
      };
      
    unless ($serialno=~/^(\d{14})$/) {
  push(@errors,"The serial number is invalid. Please enter a valid 14 digit number.");
  }
$serialno = $1;

    &getComments($serialno);
    param("add") && do {&addComment();};
    param("delete") && do {&deleteComment();};
    
    &printOldComments($serialno);

    &commentPrompt();
}


print qq!
</table>
<input type="hidden" name="serialno" value="$serialno">
</form>
<br>
<br><br>
<a href="mailto:robinson\@hep.phy.cam.ac.uk">Feedback/bug reports?</a>
</center>
</body>
</html>
!;

sub addComment {

   if(@errors) {return;}

   if($user!~/.*[\w]+.*/) {
     push(@errors,"You entered an empty or invalid name. Please try again.");
     }
   if($comment!~/.*[\w]+.*/ && !param("replacecomment")) {
     push(@errors,"You entered an empty or invalid comment. Please try again.");
     }
   
   if(@errors>0) {return;}

   my $cfile = "${lookupDir}ModuleComments/${serialno}.txt";
   
   if(param("replacecomment")) {
      if($DEBUG) {print "Replacing comment with index $index <br>\n";}
      
      if(!(exists $comments{$index})) {
        push(@errors,"Index parameters is not valid.");
	return;
	}

      $comments{$index}{COMMENT}=$comment;
      $comments{$index}{USER}=$user;
      $comments{$index}{DATE}=$theDate;
      if($DEBUG) {
        print "index=$index <br>\n";
	print "user=$user <br>\n";
	print "comment=$comment <br>\n";
	}

      updateCommentFile($cfile);
      $comment="";
      return;
      }

   my @indices = (sort by_number keys %comments);
   my $size = @indices;
   if($DEBUG) {print "old comment size=$size <br>\n";}
   my $newindex=0;
   if($size>0) {
      $newindex = $indices[-1];
      $newindex++;
      }
   if($DEBUG) {print "new index=$newindex <br>\n";}
   $comments{$newindex}{USER}=$user;
   $comments{$newindex}{DATE}=$theDate;
   $comments{$newindex}{COMMENT}=$comment;
   
   updateCommentFile($cfile);
   
   $comment="";
}

sub deleteComment() {
   if(@errors>0) {return;}
   if($DEBUG) {print "Deleting index $index <br>\n";}
   if(exists $comments{$index}) {delete $comments{$index};}
   my $cfile = "${lookupDir}ModuleComments/${serialno}.txt";
   updateCommentFile($cfile);
   }

sub updateCommentFile() {
   my $file = shift;

   #first write to backup file in case of problems
   my $backupfile="${lookupDir}ModuleComments/tmp.txt";
   if($DEBUG) {print "writing to $backupfile <br>\n";}
   if(!-e($backupfile)) {
     open(OUT,">$backupfile") || printError("Cant create $backupfile: $!");
     print OUT "";
     close(OUT) || printError("Cant close $backupfile after create");
     }

   sysopen(BACKUP, $backupfile, O_RDWR) || printError("Cant sysopen $backupfile: $!");
   flock(BACKUP,2) || printError("Cant LOCK_EX $backupfile: $!");
   truncate(BACKUP,0) || printError("Cant truncate $backupfile: $!");
  
   my $count=0;
   foreach my $i (sort by_number keys %comments) {
      print BACKUP "INDEX=${count};USER=$comments{$i}{USER};DATE=$comments{$i}{DATE}\n";
      print BACKUP "$comments{$i}{COMMENT}\n";
      $count++;
      }

   close BACKUP || printError("Cant close $backupfile: $!");

# if we made it here, it means the backup file has the data, so now write to the real file
   if($DEBUG) {print "now writing to $file <br>\n";}
   if(!-e($file)) {
     open(OUT,">$file") || printError("Cant create $file: $!");
     print OUT "";
     close(OUT) || printError("Cant close $file after create");
     }


   sysopen(OUT, $file, O_RDWR) || printError("Cant sysopen $file: $!");
   flock(OUT,2) || printError("Cant LOCK_EX $file: $!");
   truncate(OUT,0) || printError("Cant truncate $file: $!");
   
   $count=0;
   foreach my $i (sort by_number keys %comments) {
      print OUT "INDEX=${count};USER=$comments{$i}{USER};DATE=$comments{$i}{DATE}\n";
      print OUT "$comments{$i}{COMMENT}\n";
      $count++;
      }

   close OUT || printError("Cant close $file: $!");

   }


sub commentPrompt {
  foreach my $error (@errors) {
    print "<br><font color=red><b>$error</b></font>\n";
    }
  my $msg = param("edit") ? "Modify the comment highlighted in red:" : "Enter a new comment:";

  my $buttonname = param("edit") ? "Replace Comment" : "Add Comment";
  if(param("edit")) {print "<input type=\"hidden\" name=\"replacecomment\" value=\"1\">\n";}
  my $w = $totalwidth-100;
  
  my $displayedcomment = param("edit") ? $comments{$index}{COMMENT} : $comment;
  print qq!
  <br><br>
  <b>$msg</b><br>
  <table border=0 cellspacing=10>
  <col width=100>
  <col width=$w>
  <tr><td><spacer type=BLOCK WIDTH=100 HEIGHT=5></td><td><spacer type=BLOCK WIDTH=$w HEIGHT=1></td></tr>
  <tr><td align=right valign=top nowrap>
  Your Name:</td>
  <td align=left valign=top><input type="text" name="user" size="8" value=\"$user\"></td></tr>
  <tr> <td align=right valign=top>Comment(s):</td>
  <td align=left valign=top><textarea cols="80" rows="8" name="comment">$displayedcomment</textarea></td></tr>
  </table>
  <br>
  </td></tr>
  <td align=center><input type=submit name="add" value="$buttonname"></td></tr>

  !;
  }

sub getComments {
   my $serialno=shift;
   %comments=();
   my $cfile = "${lookupDir}ModuleComments/${serialno}.txt";
   if(!(-e $cfile)) {return;}

   my $index=0;
   open(IN,$cfile) || printError("Cant open comments file : $!");
   flock(IN,1) || printError("Cant flock comments file: $!");
   while(<IN>) {
     chomp($_);
     if(/INDEX=(\d+);USER=(.*);DATE=(.*)/) {
        $index=$1;
        $comments{$index}{USER}=$2;
	$comments{$index}{DATE}=$3;
	}
     else {
        if(exists($comments{$index}{COMMENT})) {$comments{$index}{COMMENT} .= "\n$_";}
	else {$comments{$index}{COMMENT}=$_;}
	}
     }
    close(IN) || printError("Cant close comments file : $!");
    }
sub printOldComments() {

my $serialno=shift;
my $ncomments = (keys %comments);

print "There are <b>$ncomments</b> comments previously entered for <b>$serialno</b> :<br><br>";
if($ncomments==0) {return;}
my $cwidth=$totalwidth-110-25;
print qq!
<table border=0>
<col width=60>
<col width=50>
<col width=$cwidth>

<col width=25>
<tr><td><spacer type=BLOCK WIDTH=50 HEIGHT=1></td><spacer type=BLOCK WIDTH=50 HEIGHT=1></td><spacer type=BLOCK WIDTH=$cwidth HEIGHT=1></td><spacer type=BLOCK WIDTH=25 HEIGHT=1></td></tr>
<tr><td><b>Date</b></td><td><b>By</b></td><td><b>Comment(s)</b></td><td><b>Remove?</b></td></tr>
!;

my $detcount=0;
foreach my $c (sort by_number keys %comments) {

  my $fontstart = (param("edit") && $index==$c) ? "<font color=red>" : "";
  my $fontend = (param("edit") && $index==$c) ? "</font>" : "";

  my $background = ($detcount%2==0) ? "bgcolor=\"#f6f6f6\"" : "bgcolor=\"#eeeeff\"";
  
  print "<tr $background>";
  print "<td align=left valign=top>${fontstart}$comments{$c}{DATE}$fontend</td>";
  my $displayedcomment =$comments{$c}{COMMENT};
  $displayedcomment =~ s/[\n]+/<br>/g;
  if($displayedcomment=~/^(.*)<br>$/) {$displayedcomment=$1;}
  my $modifyLink = param("edit") ? "" : "[<a href=$scriptname\?edit=1\&index=$c\&serialno=$serialno\&ff=$ff\&user=$comments{$c}{USER}>Modify</a>]";
  print "<td align=left valign=top>${fontstart}$comments{$c}{USER}$fontend</td>";
  print "<td align=left valign=top>${fontstart}${displayedcomment}${fontend}&nbsp;&nbsp;$modifyLink</td>";

  print "<td align=left valign=top><a href=$scriptname\?delete=1&index=$c\&serialno=$serialno\&user=$comments{$c}{USER}\&ff=$ff onClick=\"return checkDelete();\">Delete</a></td>";
  print "</tr>";
  $detcount++;
  }
print "</table>";
}


sub printAllComments() {

my $serialno=shift;
my $ncomments = (keys %comments);
if($ncomments==0) {return;}

if($startedTableList==0) {

my $cwidth=$totalwidth-210-25;
print qq!
In the table below, you can
click on the serial number to add a new comment to that module, or click on the 'Modify' or 'Delete' links.
To add a comment to a non-listed module, enter the serial number in the field above and click on the 'Enter Serial Number' button.<br>
<table border=0>
<col width=80>
<col width=60>
<col width=50>
<col width=$cwidth>
<col width=25>
<tr><td><spacer type=BLOCK WIDTH=50 HEIGHT=1></td><spacer type=BLOCK WIDTH=50 HEIGHT=1></td><spacer type=BLOCK WIDTH=50 HEIGHT=1></td><spacer type=BLOCK WIDTH=$cwidth HEIGHT=1></td><spacer type=BLOCK WIDTH=25 HEIGHT=1></td></tr>
<tr><td><b>SerialNo</td><td><b>Date</b></td><td><b>By</b></td><td><b>Comment(s)</b></td><td><b>Remove?</b></td></tr>
!;
$startedTableList=1;
}

my $detcount=0;
foreach my $c (sort by_number keys %comments) {


  my $background = ($detcount%2==0) ? "bgcolor=\"#f6f6f6\"" : "bgcolor=\"#eeeeff\"";
  print "<tr $background>";
     print "<td align=left valign=top><a href=$scriptname\?newSN=$serialno\&reqSN=$serialno\&user=$user\&ff=$ff>$serialno</a>";

  print "<td align=left valign=top>$comments{$c}{DATE}</td>";
  my $displayedcomment =$comments{$c}{COMMENT};
  $displayedcomment =~ s/[\n]+/<br>/g;
  if($displayedcomment=~/^(.*)<br>$/) {$displayedcomment=$1;}
  print "<td align=left valign=top>$comments{$c}{USER}</td>";

  print "<td align=left valign=top>${displayedcomment}&nbsp;&nbsp[<a href=$scriptname\?edit=1\&index=$c\&serialno=$serialno\&ff=$ff\&user=$comments{$c}{USER}>Modify</a>]</td>";
  print "<td align=left valign=top><a href=$scriptname\?delete=1&index=$c\&serialno=$serialno\&user=$comments{$c}{USER}\&ff=$ff onClick=\"return checkDelete();\">Delete</a></td>";
  print "</tr>";
  $detcount++;
  }
print "</table>";
}





sub printHeader {
print qq!
<HTML>
<HEAD>
   <TITLE>Module comments Database</TITLE>
   <script language="JavaScript">
        function checkDelete(form) {
	 var x=window.confirm("Are you sure you want to delete the comment?");
if (x)
return true;
else
return false;
}
</script>
<link rel=stylesheet HREF="http://www.hep.phy.cam.ac.uk/~silicon/styles/davestyles1.css" type="text/css">
</HEAD>
<BODY>
<center>
<form method="post">
<table border=0>
<col width=$totalwidth>
<tr><td><spacer type=BLOCK WIDTH=$totalwidth HEIGHT=5></td></tr>
<tr><td align=center valign=top>
<h2>Module Comments Database</h2>
<p>
!;

if($lastsite !~/$scriptname/ || $ff ne $pff) {
print qq!
Password:&nbsp;&nbsp;<input type="password" name="ff" size="8" value=\"$ff\">
<br><br><br>
<input type=submit name="enter" value="  Login  ">
<br>
<br>
!;
if($ff ne "") {print "<font color=red>Invalid password. Try again.</font><br>";}
return 1;
}
else {print "<input type=hidden name=ff value=$ff>";}

print qq!

<hr>
<br>
<input type=submit name="allcomments" value="List All Module Comments">&nbsp;&nbsp;
Or Enter a Serial Number:
&nbsp;<INPUT TYPE="TEXT" NAME="reqSN" SIZE="15" VALUE="$serialno">
&nbsp;&nbsp;&nbsp;
<input type=submit name=newSN value="Enter Serial Number">

<br><br>
<hr><br>
</td></tr>
<tr><td align=left>
!;

if($serialno eq "" && $ff eq "") {
  print qq!
  &gt; <b>Please enter a password and the serial number of a module.</b><br><br>
  Then click on the 'Enter Serial Number' button to enter a new comment or
  to view/modify/delete a previously uploaded comment for that module.<br><br>
  !;
  return 1;
  }
if($ff ne $pff) {
  print "<font color=red>Please enter a valid password.</font><br>";
  return 1;
  }
  
if($serialno !~/\d{14}/ && !param("allcomments")) {
  print qq!
  Please enter a 14-digit serial number to add/edit comments for that module.<br><br>
  Alternatively, click on the 'List All Module Comments' button to view all comments on all modules entered so far.
  <br>
  !;
  return 1;
  }


my $argcount=0;
if(param("edit")) {$argcount++;}
if(param("add")) {$argcount++;}
if(param("delete")) {$argcount++;}
if($argcount>1) {
  print "Invalid arguments to script<br>";
  return 1;
  }


return 0;

}

sub printError {
  my $emsg = shift;
  print qq!
  <h3>Error</h3>
  $emsg
  </table>
  </form>
  </body>
  </html>
  !;
  die;
  }


