#!/usr/bin/perl -w
use strict;
use CGI qw(param);
use CGI::Carp qw(fatalsToBrowser);

use lib "/userdisk/daquser/perllibs2";
#use lib "/afs/cern.ch/user/s/sctroddq/scripts/perllibs2";
use sctroddaqtests;
use webconfig;

################################################################# Do not edit anything after this line
my %runInfo = ();

my ($minute, $hour, $day, $month, $year) = (localtime)[1,2,3,4,5];
$year += 1900;
$month += 1;
$minute = "0" . $minute if ($minute<10);
$hour = "0" . $hour if ($hour<10);
$month = "0" . $month if ($month<10);
$day = "0" . $day if ($day<10);
my $shortyear = substr($year,2,3);
my $theDate = "$day/$month/$shortyear";
my $thelongDate = "$day/$month/$year";
my $datestamp = "$hour:$minute on $day/$month/$year";
my $scriptname = $ENV{'SCRIPT_NAME'};  # name of this script for links etc

my @teststates = qw{Executing Completed Aborted Unknown};

my $locn = param("locn") ? param("locn") : "Oxford";
if($locn ne "CERN" && $locn ne "Oxford") {printError("Unrecognised location");}
getConfiguration($locn);   # from webconfig.pm

my $getfilescript = "${cgi_base}getfile.cgi";
my $showMapScript = "${cgi_base}showModuleMap.cgi";
my $showMapDataScript = "${cgi_base}showModuleMapData.cgi";

if(param("plot")) {&plotdata();die;}

print "Content-type: text/html\n\n";

my $ndsets = (keys %config);
my $logbookIndex = param("logbookIndex") ? param("logbookIndex") : $ndsets;
my $tselected = param("tselected") ? 1 : 0;
my $ntrashed=0;
# my $rootDirectory = $logbookDirectories[$logbookIndex]; - from webconfig.p

my $SCT_PERSISTENT_DIR = "$rootDirectory$config{$logbookIndex}{DATADIR}/saved_data/";
my $summaryDir="$summaryRootDirectory$config{$logbookIndex}{DATADIR}/summaries/";
#my $logbookDir="$bkpDir$config{$logbookIndex}{BKP_DIR}";

my $barrel = $config{$logbookIndex}{TYPE};
$barrel += 3;
my $logbookDir ="${lookupDir}$config{$logbookIndex}{BKP_DIR}";


&printHeader();


# process parameters

SWITCH: {
    param("runcomment") && do {&showRunComment(0); last SWITCH;};
    param("showconfig") && do {&showConfigs(); last SWITCH;};
    param("moduleinfo") && do {&showModuleList(); last SWITCH;};
    param("showmoduleconfig") && do {&showModuleConfig(); last SWITCH;};
    param("listtest") && do {&listTests(); last SWITCH;};
    param("showtestsummary") && do{&showtestsummary(); last SWITCH;};
    param("viewplots") && do {&showtestsummary(); last SWITCH;};
    param("viewroot") && do {&showtestsummary(); last SWITCH;};
    param("alltests") && do {&showtestsummary(); last SWITCH;};
    showRunSummaryPage();
}

print qq!
<br>
<br><br>
<a href="mailto:robinson\@hep.phy.cam.ac.uk">Logbook feedback/bug reports?</a>
</body>
</html>
!;




sub showRunSummaryPage {
&collectRunInfo();
&printRunsummary();
}

sub noDataAvailable {
   my ($datafile) = @_;
    print qq!
    <hr><br>
    <b><font color=red>Data not available</font></b><br><br>
    Your request is not possible because the data file:<br><br>
    <b> $datafile </b>
    <br><br>
    does not exist.<br><br>
    It has probably not yet been archived.
    Data files are achived nightly to a directory which is visible to the web script, so new files (ie data taken within the last 24 hours)
    may not be available yet.
    <br><br>
    Try again soon, or if the data is more than 24 hours old then there may be a problem, in which case
    <a href="mailto:robinson\@hep.phy.cam.ac.uk">complain</a> to me.
    <br><br>
    <FORM METHOD="POST">
    <INPUT TYPE="SUBMIT" NAME="none" VALUE="  Ok  ">
    <input type="HIDDEN" name="locn" VALUE="$locn">
    </FORM>
    <br><br>
    !;
    }

sub showConfigs {

 if(!param("runno")) {&bailout("Invalid arguments to showConfigs");}

 my $runno = param("runno");
 my $type = param("config") ? param("config") : "start";   # start if not defined

 my $srunno = &removeZeros($runno);

 my $configfile = $SCT_PERSISTENT_DIR . "configArchive_" . $srunno . "_" . "$type.xml.gz";

 if(!(-e $configfile)) {
    &noDataAvailable($configfile);
    return;
    }
    
    print qq!

    <h3>Module Configuration at $type of Run $srunno</h3>
    <hr>
    !;

    my $xmlcontent = `gunzip -c $configfile`;
    $xmlcontent =~ s/</\&lt\;/g;
    $xmlcontent =~ s/>/\&gt\;/g;
    my @lines = split(/[\n\r]+/,$xmlcontent);
    foreach my $line (@lines) {print "$line <br>\n";}
    print "<hr><br><br>";
    print "&gt <a href=\"$scriptname\?locn=$locn\&logbookIndex=$logbookIndex\&tselected=$tselected\">Click here</a> to go back to Run History page</a><br>";
    }


sub showModuleConfig {

# params are showmoduleconfig=$runno\&module=$modulesn\&nmodules=$nmodules\&type=xxx
 
 if(!param("runno") || !param("module") || !param("nmodules") || !param("type")) {&bailout("invalid args to showmoduleConfig");}
 
 my $runno = param("runno");
 my $type = param("type");
 my $nmodules = param("nmodules");
 my $modulesn = param("module");


 my $srunno = &removeZeros($runno);

 my $configfile = $SCT_PERSISTENT_DIR . "configArchive_" . $srunno . "_" . "$type.xml.gz";

 if(!(-e $configfile)) {
    &noDataAvailable($configfile);
    return;
    }
    
    print qq!

    <h3>Configuration of $modulesn at $type of Run $srunno</h3>
    <hr>
    !;

    my $xmlcontent = `gunzip -c $configfile`;
#    $xmlcontent =~ s/</\&lt\;/g;
#    $xmlcontent =~ s/>/\&gt\;/g;
    my @lines = split(/[\n\r]+/,$xmlcontent);
    my $printout=0;
    my $linecount=0;
    foreach my $line (@lines) {
     if($line=~/<sn>(\d{14})<\/sn>/ && $1 eq $modulesn) {$printout=1;}
     if($line=~/.*<\/module>.*/) {$printout=0;}
     if($printout==1 & $linecount==0) {print "&lt\;module&gt\;<br>";}
     if($printout>0) {
       $linecount++;
       $line =~ s/</\&lt\;/g;
       $line =~ s/>/\&gt\;/g;
       print "$line <br>\n";
       }
     }
    print "<hr><br><br>";
    print "&gt <a href=\"$scriptname\?locn=$locn\&moduleinfo=1\&runno=$runno&nmodules=$nmodules\&logbookIndex=$logbookIndex\&tselected=$tselected\">Click here</a> to return to the module list for Run $runno<br>";
    print "&gt <a href=\"$scriptname\?locn=$locn\&listtest=1\&runno=$runno\&nmodules=$nmodules\&logbookIndex=$logbookIndex\&tselected=$tselected\">Click here</a> to return to Run $runno<br>";
    print "&gt <a href=\"$scriptname\?locn=$locn\&logbookIndex=$logbookIndex\&tselected=$tselected\">Click here</a> to go back to Run History page</a><br>";
    }


sub showModuleList {

 if(!param("runno") || !param("nmodules")) {&bailout("Invalid arguments to showModuleList");}
 my $runno = param("runno");
 my $type = "start";   # start if not defined

 my $srunno = &removeZeros($runno);
 my $nmodules = param("nmodules");

 my $configfile = $SCT_PERSISTENT_DIR . "configArchive_" . $srunno . "_" . "$type.xml.gz";

 if(!(-e $configfile)) {
    &noDataAvailable($configfile);
    return;
    }

    print qq!

    <h3>Modules in Run $srunno</h3>

    !;

    my %module=();

    my $xmlcontent = `gunzip -c $configfile`;
#    $xmlcontent =~ s/</\&lt\;/g;
#    $xmlcontent =~ s/>/\&gt\;/g;
    my @lines = split(/[\n\r]+/,$xmlcontent);
    my $comment=0;
    foreach my $line (@lines) {
      if($line=~/(.*)<\!--.*-->(.*)/) {$line="$1$2";}
      if($line=~/(.*)<\!--.*/) {$line=$1; $comment=1;}
      if($line=~/.*-->(.*)/) {$line=$1; $comment=0;}


      if($comment==1) {next;}
      if($line=~/.*module\s+id=\"(\d+)\"\s+group=\"(\d+)\".*(\d{14}).*module.*/) {
         $module{$3}{ID}=$1;
         $module{$3}{GROUP}=$2;
	 next;
	 }
      }


   print qq!
   <table cellspacing="0" cellpadding="0" border="0">
<col width=120 align="left">
<col width=60 align="left">
<col width=70 align="left">
<col width=70 align="left">


<tr>
<td><spacer type=BLOCK WIDTH=120 HEIGHT=10></td>
<td><spacer type=BLOCK WIDTH=60 HEIGHT=10></td>
<td><spacer type=BLOCK WIDTH=70 HEIGHT=10></td>
<td><spacer type=BLOCK WIDTH=70 HEIGHT=10></td>

</tr>
<tr><td colspan=4><hr></td></tr>

<tr>
<td nowrap><b>Serial No</b></td>
<td nowrap><b>Group</b></td>
<td colspan=2 align=center nowrap><b>Config Files</b></td>

</tr>
!;

  my $detcount=0;
  foreach my $modulesn (sort keys %module) {
     my $moduleLinkstart = "<a href=\"$scriptname\?locn=$locn\&showmoduleconfig=1\&runno=$runno\&module=$modulesn\&nmodules=$nmodules&type=start\&logbookIndex=$logbookIndex\&tselected=$tselected\">View start</a>";
     my $moduleLinkend = "<a href=\"$scriptname\?locn=$locn\&showmoduleconfig=1\&runno=$runno\&module=$modulesn\&nmodules=$nmodules&type=end\&logbookIndex=$logbookIndex\&tselected=$tselected\">View end</a>";
     my $background = ($detcount%2==0) ? "bgcolor=\"#f6f6f6\"" : "bgcolor=\"#eeeeff\"";
     print "<tr $background><td align=left valign=top>$modulesn</td><td align=left valign=top>$module{$modulesn}{GROUP}</td><td align=left valign=top>$moduleLinkstart</td><td align=left valign=top>$moduleLinkend</td></tr>\n";
     $detcount++;
     }


print "<tr><td colspan=4><hr></td></tr>\n";

  print "</table>";

  print "<br><br>";
  print "&gt <a href=\"$scriptname\?locn=$locn\&listtest=1\&runno=$runno\&nmodules=$nmodules\&logbookIndex=$logbookIndex\&tselected=$tselected\">Click here</a> to return to Run $runno<br>";
  print "&gt <a href=\"$scriptname\?locn=$locn\&logbookIndex=$logbookIndex\&tselected=$tselected\">Click here</a> to go back to Run History page</a><br>";
  }


### finished

sub bailout {

    my $error = "@_";

    print <<bailout_marker;
    <b> &gt Request Failed!</b>
    <br><br>
      Reason: $error
    <br><br>
    Sorry!
<br><br>
</body></html>
bailout_marker

die "$error";

}

sub listTests {


   if(!param("listtest") || !param("runno")) {&bailout("Invalid arguments to listTests");}

   my $thisRun = param("runno");
   my $srunno = &removeZeros($thisRun);
   my $noModules = param("nmodules") ? param("nmodules") : getNumberOfModules($thisRun);
    $thisRun = addZeros($thisRun);
    my $runDir = "RUN$thisRun";
    my $indexfile = "$logbookDir$runDir/index.txt";
    open(IN,$indexfile) || bailout("Cant open test index file $indexfile : $!");
    flock(IN,1) || bailout("Cant get LOCK_SH on $indexfile: $!");


print qq!

<h3>Data for Run $srunno</h3>
Hints:<br>
&gt To view the modules in this run, and their config data, click on <i>the number of modules</i><br>
&gt To view the overall configuration, click on the <i>module configuration</i> links<br>
&gt To view test result and links to plots, click on the <i>test name</i><br><br>

There were <a href=\"$scriptname\?locn=$locn\&moduleinfo=1\&runno=$thisRun\&nmodules=$noModules\&logbookIndex=$logbookIndex\&tselected=$tselected\">$noModules modules</a> in this run.
<br><br>

<b>Module Configurations for this run:</b>
&nbsp;&nbsp;&nbsp;
<a href=\"$scriptname\?locn=$locn\&showconfig=1\&runno=$thisRun\&config=start\&logbookIndex=$logbookIndex\&tselected=$tselected\">At Run Start</a>
&nbsp;&nbsp;&nbsp;-&nbsp;&nbsp;&nbsp;
<a href=\"$scriptname\?locn=$locn\&showconfig=1\&runno=$thisRun\&config=end\&logbookIndex=$logbookIndex\&tselected=$tselected\">At Run End</a>


<br><br>

<table cellspacing="0" cellpadding="0" border="0">
<col width=120 align="left">
<col width=60 align="left">
<col width=60 align="left">
<col width=80 align="left">
<col width=60 align="left">
<col width=60 align="left">
<col width=90 align="left">
<col width=320 align="left">

<tr>
<td><spacer type=BLOCK WIDTH=120 HEIGHT=10></td>
<td><spacer type=BLOCK WIDTH=60 HEIGHT=10></td>
<td><spacer type=BLOCK WIDTH=60 HEIGHT=10></td>
<td><spacer type=BLOCK WIDTH=80 HEIGHT=10></td>
<td><spacer type=BLOCK WIDTH=60 HEIGHT=10></td>
<td><spacer type=BLOCK WIDTH=60 HEIGHT=10></td>
<td><spacer type=BLOCK WIDTH=90 HEIGHT=10></td>
<td><spacer type=BLOCK WIDTH=320 HEIGHT=10></td>
</tr>

<tr><td colspan=8><hr></td></tr>

<tr>
<td nowrap><b>Test</b></td>
<td nowrap><b>Scan</b></td>
<td nowrap><b>#Scans</b></td>
<td nowrap><b>Date</b></td>
<td nowrap><b>Started</b></td>
<td nowrap><b>Ended</b></td>
<td nowrap><b>Status</b></td>
<td nowrap><b>Comments</b></td>
</tr>
!;

my $detcount=0;

    while(<IN>) {
        my $background = ($detcount%2==0) ? "bgcolor=\"#f6f6f6\"" : "bgcolor=\"#eeeeff\"";
#RUN=1367;NAME=NMaskTest;START=1;NSCANS=1;DATE=17/08/2004;STIME=20040817T100755;ETIME=20040817T100909;STATUS=1;NMODULES=14
          if(/.*NAME=(\w+);START=(\d+);NSCANS=(\d+);DATE=(\d+\/\d+\/\d+);STIME=\d+T(\d{2})(\d{2})\d{2};ETIME=(.*);STATUS=(\d+).*/) {

#	  print "#### commentfile = $commentFile\n";

            my $comment = "<font color=red>None</font>";
	    my $teststatus=$8;


            my $status = ($teststatus>4 || $teststatus<0) ? "Unknown" : $teststates[$teststatus];
            my $startscan=$2;
	    my $testDir = &addZeros($startscan,6);
	    my $runDir = "RUN$thisRun";
	    my $noscans = $3;
	    my $date =$4;
	    my $stime="$5:$6";
	    my $etime = $7;

            my $testcommentfile = "$logbookDir$runDir/TEST$testDir".".txt";
  	    if(-e $testcommentfile) {$comment = &getComment($testcommentfile,$thisRun,$startscan);}
	    my $testlink = "<a href=\"$scriptname\?locn=$locn\&showtestsummary=1\&testname=$1\&runno=$thisRun\&tselected=$tselected\&scanno=$startscan\&nmodules=$noModules\&noscans=$noscans\&logbookIndex=$logbookIndex\">$1</a>";

	    $etime = ($etime=~/\d+T(\d{2})(\d{2})\d{2}/) ? "$1:$2" : "<font color=red>Not finished</font>";

	    print qq!
             <tr $background>
	     <td align=left valign=top nowrap>$testlink</td>
             <td align=left valign=top nowrap>$startscan</td>
             <td align=left valign=top nowrap>$noscans</td>
             <td align=left valign=top nowrap>$date</td>
             <td align=left valign=top nowrap>$stime</td>
             <td align=left valign=top nowrap>$etime</td>
             <td align=left valign=top nowrap>$status</td>
             <td align=left valign=top nowrap>$comment</td>
             </tr>
             !;

	       $detcount++;
	       }
             }

           close(IN) || bailout("Cant close index file $indexfile: $!");

print "<tr><td colspan=8><hr></td></tr>\n";
print "</table>";
print "<br><br>";
print "&gt <a href=\"$scriptname\?locn=$locn\&logbookIndex=$logbookIndex\&tselected=$tselected\">Click here</a> to return to the Run History page.</a>";
}



sub printRunsummary {


print "This page is currently displaying the log book for <b>$config{$logbookIndex}{TITLE}</b><br><br>";

my $entries = (keys %runInfo);
if($entries==0) {
  print qq!
  <br>
  There are <b>no entries</b> yet in the this logbook</b>.
  Please select an alternative logbook in the list at the top of this page.
  !;
  return;
  }
if($tselected) {
  print "Note there are <b><font color=red>$ntrashed</font></b> runs flagged as trash which are excluded from this list. ";
  print "<a href=$scriptname\?locn=$locn\&tselected=0\&logbookIndex=$logbookIndex>Click here</a> to include them.";
  }
else {
  print "<a href=$scriptname\?locn=$locn\&tselected=1\&logbookIndex=$logbookIndex>Click here</a> to exclude trashed runs from the list.";
  }

print qq!
<table cellspacing="0" cellpadding="0" border="0">
<col width=70 align="left">
<col width=80 align="left">
<col width=60 align="left">
<col width=60 align="left">
<col width=60 align="left">
<col width=60 align="left">
<col width=60 align="left">
<col width=320 align="left">

<tr>
<td><spacer type=BLOCK WIDTH=70 HEIGHT=10></td>
<td><spacer type=BLOCK WIDTH=80 HEIGHT=10></td>
<td><spacer type=BLOCK WIDTH=60 HEIGHT=10></td>
<td><spacer type=BLOCK WIDTH=60 HEIGHT=10></td>
<td><spacer type=BLOCK WIDTH=60 HEIGHT=10></td>
<td><spacer type=BLOCK WIDTH=60 HEIGHT=10></td>
<td><spacer type=BLOCK WIDTH=60 HEIGHT=10></td>
<td><spacer type=BLOCK WIDTH=320 HEIGHT=10></td>
</tr>

<tr><td colspan=8><hr></td></tr>

<tr>
<td><b>Run No</b></td>
<td nowrap><b>Date</b></td>
<td nowrap><b>Start</b></td>
<td nowrap><b>#Tests</b></td>
<td nowrap><b>#Scans</b></td>
<td nowrap><b>#Modules</b></td>
<td nowrap><b>Status</b></td>
<td nowrap><b>Comments</b></td>
</tr>
!;

my $detcount=0;


  foreach my $runno (sort keys %runInfo) {
     my $runLink = "<a href=\"$scriptname\?locn=$locn\&listtest=1\&runno=$runno\&nmodules=$runInfo{$runno}{MODULECOUNT}\&tselected=$tselected\&logbookIndex=$logbookIndex\">$runno</a>";
     my $background = ($detcount%2==0) ? "bgcolor=\"#f6f6f6\"" : "bgcolor=\"#eeeeff\"";
     print "<tr $background><td align=left valign=top>$runLink</td><td align=left valign=top>$runInfo{$runno}{DATE}</td><td align=left valign=top>$runInfo{$runno}{START_TIME}</td><td align=left valign=top>$runInfo{$runno}{TESTCOUNT}</td><td align=left valign=top>$runInfo{$runno}{SCANCOUNT}</td><td align=left valign=top>$runInfo{$runno}{MODULECOUNT}</td><td align=left valign=top>$runInfo{$runno}{STATUS}</td><td align=left valign=top>$runInfo{$runno}{COMMENT}</td></tr>\n";
     $detcount++;
     }

print "<tr><td colspan=8><hr></td></tr>\n";
print "</table>";
}

sub printHeader {
print qq!
<HTML>
<HEAD>
   <TITLE>SctRodDaq MacroAssembly Book-Keeping at  $instituteName</TITLE>
<link rel=stylesheet HREF="http://www-pnp.physics.ox.ac.uk/~daquser/styles/davestyles2.css" type="text/css">
</HEAD>
<BODY>
<h2>SctRodDaq MacroAssembly Book-Keeping at $instituteName</h2>
!;
my $mname = $showMapScript . "\?index=$config{$logbookIndex}{TYPE}";
my $sname = $showMapScript . "\?currentconfig=1\&index=$config{$logbookIndex}{TYPE}\&locn=$locn";
print qq!
Other web tools (require javascript enabled) :&nbsp;&nbsp;
<a href="#" onClick="window.open('$showMapDataScript\?locn=$locn','DataDisplay','menubar=1,scrollbars=1,resizable=1'); return false;">Data Displays</a>
&nbsp;&nbsp;&nbsp;-&nbsp;&nbsp;&nbsp;
<a href="#" onClick="window.open('$mname','BarrelMapping','menubar=1,scrollbars=1,resizable=1'); return false;">Assembly Maps</a>
&nbsp;&nbsp;&nbsp;-&nbsp;&nbsp;&nbsp;
<a href="#" onClick="window.open('$sname','BarrelMapping','menubar=1,scrollbars=1,resizable=1'); return false;">Current SctRodDaq Configuration</a>
<br>
<p>
<form method="POST">
Select LogBook:&nbsp;&nbsp;<SELECT name=logbookIndex>
!;
my $ndsets = (keys %config);
for (my $i=$ndsets;$i>0;$i--) {
    my $selectflag = ($logbookIndex == $i) ? "SELECTED" : "";
    my $title = ($i==0) ? "$config{$i}{TITLE}" : $config{$i}{TITLE};
    print "<option value=$i $selectflag>$title</option>\n";
    }
print qq!
</SELECT>
&nbsp;&nbsp;&nbsp;
<INPUT TYPE="SUBMIT" NAME="listlog" VALUE="Switch Logbook">
<input type="HIDDEN" name="tselected" VALUE="$tselected">
<input type="HIDDEN" name="locn" VALUE="$locn">
</form>
<br>
!;

}

sub collectRunInfo {

%runInfo=();


opendir(HDATA,$logbookDir) || bailout("Cant open directory $logbookDir: $!");


while(my $runname = readdir(HDATA)) {

      my $comment = "<font color=red>None</font>";
      my $testCount=0;
      my $scanCount=0;
      my $startTime="";
      my $runDate="";
      my $nmodules=0;

      if($runname =~/RUN(\d{6})/ && -d "$logbookDir$runname") {
          my $thisRun=$1;
	  my $trashfile = "$logbookDir$runname/trashed.txt";
	  my $trashStatus = "Ok";
	  if(-e $trashfile) {
	     $ntrashed++;
	     if($tselected) {next;}
	     $trashStatus = "<font color=red>Trash</font>";
	     }
          my $indexFile = "$logbookDir$runname/index.txt";
	  if(!(-e $indexFile)) {next;}   # require at least one test
	  my $commentFile = "$logbookDir$runname/comments.txt";
#	  print "#### commentfile = $commentFile\n";

	  if(-e $commentFile) {$comment = &getComment($commentFile,$thisRun,-1);}

          open(IN,$indexFile) || bailout("Cant open $indexFile: $!");
          flock(IN,1) || bailout("Cant get LOCK_SH on $indexFile: $!");


          while(<IN>) {
#	  RUN=1367;NAME=NMaskTest;START=1;NSCANS=1;DATE=17/08/2004;STIME=20040817T100755;ETIME=20040817T100909;STATUS=1;NMODULES=14
            if(/RUN=(\d+).*NSCANS=(\d+);DATE=(\d+\/\d+\/\d+);STIME=\d+T(\d{2})(\d{2})\d{2}.*;NMODULES=(\d+)/) {
	       my $runno=$1;
	       my $nscans=$2;
	       my $date = $3;
	       my $start_time="$4:$5";
	       $nmodules = $6;

	       $testCount++;
	       $scanCount+=$nscans;
	       if($startTime eq "") {$startTime = $start_time;}
	       if($runDate eq "") {$runDate=$date;}
	       }
             }

           close(IN) || bailout("Cant close $indexFile: $!");
           $runInfo{$thisRun}{SCANCOUNT}=$scanCount;
	   $runInfo{$thisRun}{MODULECOUNT}=$nmodules;
	   $runInfo{$thisRun}{TESTCOUNT}=$testCount;
	   $runInfo{$thisRun}{DATE}=$runDate;
	   $runInfo{$thisRun}{START_TIME}=$startTime;
	   $runInfo{$thisRun}{COMMENT}=$comment;
           $runInfo{$thisRun}{STATUS}=$trashStatus;


      }
   }


closedir(HDATA);
}

sub getComment {

    my $comment="";

    my ($commentfile,$thisRun,$thisTest) = @_;
    open(IN3,$commentfile) || bailout("Cant open comment file $commentfile : $!");
    flock(IN3,1) || bailout("Cant get LOCK_SH on $commentfile: $!");
    my $firstline="";
    my $linecount=0;
    while(<IN3>) {
      if($linecount==0) {$firstline=$_;}
      $linecount++;
      }
    close(IN3) || bailout("Cant close $commentfile : $!");
    $_ = $firstline;
    my $count = tr/a-zA-Z0-9 -\.!\?//;
    if($count>60 || $linecount>1) {$comment = substr($firstline,0,50) . "... <a href=\"$scriptname\?locn=$locn\&runcomment=1\&runno=$thisRun\&test=$thisTest\&logbookIndex=$logbookIndex\&tselected=$tselected\">More...</a>";}
    else {$comment=$firstline;}
    if($comment eq "" || $comment!~/[.*\w+.*]/) {$comment = "<font color=red>None</font>";}
    return $comment;
}


sub showRunComment {

    my $inReport = shift;


    if(!param("runno")) {&bailout("Invalid arguments to showRunComment");}

    my ($thisRun) = param("runno");
    my $thisTest = param("test");
    if($thisTest eq "-1") {print "<h3>Comments for Run $thisRun </h3>";}
    else {
      print "<h3>Comments for Run/Scan $thisRun/$thisTest </h3>";
      }
    my $runDir = "RUN$thisRun";
    my $testDir = "TEST";
    if($thisTest ne "-1") {
       my $testno = &addZeros($thisTest);
       $testDir.=$testno;
       }
    my $commentfile = ($thisTest eq "-1") ? "$logbookDir$runDir/comments.txt" : "$logbookDir$runDir/$testDir".".txt";
 
    if(-e $commentfile) {
    open(IN2,$commentfile) || bailout("Cant open comment file $commentfile : $!");
    flock(IN2,1) || bailout("Cant get LOCK_SH on $commentfile: $!");

    while(<IN2>) {
      print;
      print "<br>";
      }
    close(IN2) || bailout("Cant close commentfile $commentfile : $!");
    }
    else {
      print "No comments entered for this run...<br>\n";
      }
    print "<br><br>";
    if(! $inReport) {print "&gt <a href=\"$scriptname\?locn=$locn\&logbookIndex=$logbookIndex\&tselected=$tselected\">Click here</a> to go back to Run History page</a>";}
}

sub getModuleList {
 my ($runno) = @_;
 
 my @modulelist=();

 my $type = "start";   # start if not defined

 my $srunno = &removeZeros($runno);

 my $configfile = $SCT_PERSISTENT_DIR . "configArchive_" . $srunno . "_" . "$type.xml.gz";

 if(!(-e $configfile)) {
    &noDataAvailable($configfile);
    push(@modulelist,"Module list nont available");
    return @modulelist;
    }

    my $xmlcontent = `gunzip -c $configfile`;
    my @lines = split(/[\n\r]+/,$xmlcontent);
    my $comment=0;
    foreach my $line (@lines) {
      if($line=~/(.*)<\!--.*-->(.*)/) {$line="$1$2";}
      if($line=~/(.*)<\!--.*/) {$line=$1; $comment=1;}
      if($line=~/.*-->(.*)/) {$line=$1; $comment=0;}


      if($comment==1) {next;}
      if($line=~/.*module\s+id=\"(\d+)\"\s+group=\"(\d+)\".*(\d{14}).*module.*/) {
         push(@modulelist,$3);
	 next;
	 }
      }

      return @modulelist;
      }

sub showtestsummary {
  my $serialno = param("serialno") ? param("serialno") : "None";
  my $runno = param("runno");
  my $scanno = param("scanno");
  my $testname = param("testname");
  my $nmodules = param("nmodules");
  my $noscans = param("noscans");
  
  my $plottype = param("plotteddata") ? param("plotteddata") : "None";
  
  my $srunno = &removeZeros($runno);
  
  print qq!
  <form method="POST">
  <table border=0 cellspacing=5 cellpadding=0>
  <col width=200>
  <col width=200>


  <tr><td colspan=2><hr></td></tr>
  <tr><td colspan=2 align=center><b><font color=navy>View Data for $testname (Run/Scan $srunno/$scanno)</font></b></td></tr>
  <tr><td colspan=2><br></td></tr>
  <tr><td align=right valign=top>Select Serial No:</td>
  <td align=left><SELECT NAME="serialno">
  !;

  my @modulelist = &getModuleList($runno);

  foreach(sort @modulelist) {
    my $selectflag = ($serialno eq $_) ? "SELECTED" : "";
    print "<option value=$_ $selectflag>$_</option>\n";
    }

    #<tr><td colspan=2 align=center><INPUT TYPE="SUBMIT" NAME="showtestsummary" VALUE="View Test Summary" onClick="return checkFields(this.form);"></td></tr>
  print qq!
  </SELECT><td></tr>
  <tr><td align=right>Scan No:</td>
  <td align=left><SELECT NAME="selectedscan">
  !;
  for(my $i=$scanno;$i<$scanno+$noscans;$i++) {
    my $index = $i-$scanno;
    my $selectflag = (param("selectedscan") && $i eq param("selectedscan")) ? " SELECTED" : "";
    print "<option value=$i$selectflag>$i (scan index $index)</option>";
    }
  print qq!
  </SELECT></td></tr>

  <tr><td align=right>Plot Data:</td>
  <td align=left><SELECT NAME="plotteddata">
  <option value="analysed">Analysed Data</option>
  !;
  if($plottype eq "raw") {print "<option value=\"raw\" SELECTED>Raw Data</option>";}
  else {print "<option value=\"raw\">Raw Data</option>";}
  if($plottype eq "fitted") {print "<option value=\"fitted\" SELECTED>Fitted Data</option>";}
  else {print "<option value=\"fitted\">Fitted Data</option>";}



  my $occselect = param("occupancy") ? "checked" : "";
 
  my $backlinks = "&gt;&nbsp;<a href=\"$scriptname\?locn=$locn\&listtest=1\&runno=$runno\&nmodules=$nmodules\&tselected=$tselected\&logbookIndex=$logbookIndex\">Click here</a> to return to Run $runno &nbsp;&nbsp;&nbsp;&gt;&nbsp;<a href=\"$scriptname\?locn=$locn\&logbookIndex=$logbookIndex\&tselected=$tselected\">Click here</a> to go back to Run History page</a> <br>";


  print qq!
  </SELECT></td>

  <tr><td colspan=2 align=center nowrap><INPUT TYPE="CHECKBOX" NAME=occupancy VALUE="yes" $occselect>&nbsp;Tick to include Occupancy Data in Plots</td></tr>


  <tr><td colspan=2 align=center><INPUT TYPE="SUBMIT" NAME="showtestsummary" VALUE="View Test Summary"></td></tr>
  <tr><td colspan=2 align=center><INPUT TYPE="SUBMIT" NAME="viewplots" VALUE="Generate Plots (eps)"></td></tr>
  <tr><td colspan=2 align=center><INPUT TYPE="SUBMIT" NAME="viewroot" VALUE="Generate ROOT files"></td></tr>
  <tr><td colspan=2 align=center><INPUT TYPE="SUBMIT" NAME="alltests" VALUE="List ALL tests of selected module""></td></tr>
  <tr><td colspan=2><br></td></tr>
  <tr><td colspan=2><hr></td></tr>

  </table>
  <br>
  $backlinks

  <input type="HIDDEN" name="runno" VALUE="$runno">
  <input type="HIDDEN" name="scanno" VALUE="$scanno">
  <input type="HIDDEN" name="testname" VALUE="$testname">
  <input type="HIDDEN" name="nmodules" VALUE="$nmodules">
  <input type="HIDDEN" name="noscans" VALUE="$noscans">
  <input type="HIDDEN" name="logbookIndex" VALUE="$logbookIndex">
  <input type="HIDDEN" name="tselected" VALUE="$tselected">
  <input type="HIDDEN" name="locn" VALUE="$locn">
  </form>
  <br><br>
  !;

if($serialno!~/\d{14}/) {return;}

  my $tname="";
  my $scan_index = $scanno;

  if($plottype eq "raw") {
      $tname = "RawScanResult";
      $scan_index = param("selectedscan");
      }
  elsif($plottype eq "fitted") {
      $tname = "FitScanResult";
      $scan_index = param("selectedscan");
      }
  else {
      $tname = $testname . "Result";
      }

  my $fname = "${SCT_PERSISTENT_DIR}../run${srunno}/SctData::${tname}.${srunno}.${scan_index}.${serialno}.gz";
  if(!-e($fname)) {
  $fname = $SCT_PERSISTENT_DIR . "SctData::" . $tname . "." . $srunno . "." . $scan_index . "." . $serialno . ".gz";
  }



  my $oldPATH = $ENV{"PATH"};
  my $old_LD_LIBRARY_PATH = $ENV{"LD_LIBRARY_PATH"};

# Setup for Oxford on pplxgen

  $ENV{"ROOTSYS"} = "/userdisk/daquser/root32";

  $ENV{"PATH"}="/userdisk/daquser/root32/bin:/userdisk/daquser/SctRodDaq/installed/i686-rh73-gcc32-opt/bin:/usr/local/bin:/bin:/usr/bin:/usr/X11R6/bin";

  $ENV{"LD_LIBRARY_PATH"}="/userdisk/daquser/SctRodDaq/gcc/gcc-3.2.3/lib:/userdisk/daquser/SctRodDaq/root32/lib:/userdisk/daquser/SctRodDaq/online-00-22-00/installed/i686-rh73-gcc32-opt/lib:/userdisk/daquser/SctRodDaq/installed/i686-rh73-gcc32-opt/lib";


  if(param("showtestsummary")) {my $name = "${testname}Result"; parseSummaryData($summaryDir,$runno,$scanno,$name,$serialno);}
  elsif(param("alltests")) {printModuleTestList($summaryDir,$logbookIndex,$serialno,$scriptname,"");}
  else {
    if(!(-e $fname)) {
    &noDataAvailable($fname);
    return;
    }
    
    my $occflag = param("occupancy") ? "-occ" : "";
    my $rootflag = param("viewroot") ? "-root" : "";
    my $msg = ($rootflag eq "") ? "Plots" : "Root files";

    print "<h3>$msg generated of $plottype data for $serialno, for Run $srunno, Scan $scan_index</h3><br>";
#    print "DataDisplayer $occflag $rootflag -dir $plot_DIR $fname <br>\n";
    
    my $output = `DataDisplayer $occflag $rootflag -dir $plot_DIR $fname`;
    my @lines = split(/[\n\r]+/,$output);
    my @epsfiles=();
    my @rootfiles=();
    my $txtfile="";
    foreach (@lines) {
      if(/.*TEXT\s*(.*)/) {$txtfile=$1;}
      if(/.*FILE\s*(.*\.eps).*/) {push(@epsfiles,$1);}
      if(/.*FILE\s*(.*\.root).*/) {push(@rootfiles,$1);}
      }
  my $nfiles = @epsfiles+@rootfiles;
  if($nfiles>0) {
    print "$nfiles $msg have been generated - click to view:<br><br>\n";
   foreach (@epsfiles) {
    if(/.*\/(.*\.eps)/) {
      my $fname = $1;
      if(-e $_) {print "<a href=\"#\" onClick=\"window.open('$scriptname\?locn=$locn\&plot=1\&fname=$fname','Plot'); return false;\">$fname</a><br>\n";}
      else {print "$_ <br>\n";}
    }
    }
    foreach (@rootfiles) {
      if(/.*\/(.*\.root)/) {
      my $fname = $1;
      if(-e "${plot_DIR}/$fname") {print "<a href=\"${plot_http}$fname\">$fname</a><br>\n";}
      else {print "$_ was generated, but is not viewable...<br>\n";}
    }
    }
  }
  else {
    print "<b><font color=red>Sorry, no plots have been generated.</font></b><br><br>\n";
    }

  if(-e $txtfile && ($plottype eq "analysed")) {
   print "<br><br><b><font color=navy>Information generated by DataDisplayer:</font></b><br>";
    open(IN,$txtfile) || bailout("Cant open test index file $txtfile : $!");
    flock(IN,1) || bailout("Cant get LOCK_SH on $txtfile: $!");
    while(<IN>) {
      print "$_ <br>\n";
      }
    close(IN) || bailout("Cant close $txtfile : $!");
    unlink($txtfile);
    }
  }

  $ENV{"PATH"}=$oldPATH;
  $ENV{"LD_LIBRARY_PATH"}=$old_LD_LIBRARY_PATH;
  }
  
  sub plotdata {
  
  if(!param("fname")) {&bailout("no data file name specified");}
  
  my $fullfilename = $plot_DIR . "/" . param("fname");

  open(IN,$fullfilename) || &bailout("Cant open $fullfilename");

  print "Content-type: application/postscript\n\n";

  while(<IN>) {print $_;}

  close(IN) || &bailout("Cant close $fullfilename");
}


